;;; -*- Mode:Common-Lisp; Package:COMMON-LISP-USER; Base:10 -*-

;;; Copyright (c) 1999 - 2009 Brian C. Williams, MIT.

;;; This software may not be redistributed, and can only be retained
;;; and used with the explicit written consent of the author,
;;; Brian C. Williams.

;;; This software is made available as is; no guarantee is provided
;;; with respect to performance or correct behavior.

;;; This software may only be used for non-commercial, non-profit,
;;; research activities.

(in-package :COMMON-LISP-USER)

(pushnew :BFIG *features*)

(defpackage :BFIG (:use "MTK-UTILS" 
						;;;"CLOS" 
						"COMMON-LISP"
						#:adt)
			(:export
			 ;; From bfig-defs.lisp
			 "INITIALIZE-BIT-HT!"
			 "*ALWAYS-ACTIVE*"
			 
			 "*ALLOWED-SEARCH-ORDER-TYPES*"
			 "*DEFAULT-SEARCH-PROBLEM*"

			 "STATE-SPACE-SOURCE"
			 "STATE-SPACE-VARIABLES"
			 
			 "STATE-SPACE-W-CONFLICTS"
			 
			 "DECISION-SPACE-BINARY-OBJECTIVE-FUNCTION"
			 
			 "SEARCH-PROBLEM-W-CONFLICTS"
			 "MAKE-SEARCH-PROBLEM"
			 "SEARCH-PROBLEM-SEARCH-ORDER"

			 "SEARCH-PROBLEM-SOLUTIONS"
			 "SEARCH-PROBLEM-BEST-SOLUTION-COST"

			 "SEARCH-PROBLEM-SOLUTION-COUNT"
			 "SEARCH-PROBLEM-CANDIDATE-COUNT"

			  "INFORMED-SEARCH-PROBLEM"
			 
			 "INFORMED-SEARCH-PROBLEM-W-CONFLICTS"
			 "INFORMED-SEARCH-PROBLEM-W-CONFLICTS-VCSP"
			 
			 "CONDITIONAL-SEARCH-PROBLEM-W-CONFLICTS"
			 "INFORMED-CONDITIONAL-SEARCH-PROBLEM-W-CONFLICTS"

			 "FIRST-SOLUTION-FOUND?"

			 "SEARCH-NODE-BEST-COST"
			 "SEARCH-NODE-ASSIGNMENTS"
			 "SEARCH-NODE-ANCESTOR-ASSIGNMENTS"

			 "SEARCH-NODE-PREFERRED-CHILD-ASSIGNMENT"
			 "SEARCH-NODE-PREFERRED-EXPANSION"
	    
			 "STATE-VARIABLE-DOMAIN"
			 "STATE-VARIABLE-PREVIOUS-ASSIGNMENT"
			 "STATE-VARIABLE-CURRENT-ASSIGNMENT"
			 
			 "DECISION-VARIABLE-BEST-ASSIGNMENT"
	    
			 "STATE-ASSIGNMENT-VARIABLE"
			 "STATE-ASSIGNMENT-VALUE"
			 "STATE-ASSIGNMENT-TO-CONSTRAINT-ASSIGNMENT"

			 "GET-ASSIGNMENT-FROM-HASH"

			 "NEW-SOFT-CONSTRAINT-LIST"

			 "SHORTEST-RESOLVABLE-CONFLICT"
			 
			 "INFORMED-SEARCH-NODE-W-CONFLICTS"

			 "IS-ORDERED?"
			 
			 ;; From bfig-state-space.lisp
			 "ADD-VARIABLE"
			 "ADD-OBJECTIVE-FUNCTION!"

			 "EXTERNALIZE-STATE-ASSIGNMENTS"
			 
			 ;; from bfig-generator.lisp
			 "INITIALIZE-CANDIDATE-GENERATOR!"
			 "NEXT-CANDIDATE"
			 "NEXT-MINIMAL-RELAXATION-CANDIDATE"
			 "CANDIDATE-IS-SOLUTION!"
;;;			 "INITIALIZE-BEST-FIRST-IMPLICANT-GENERATOR" ->
;;;			 "NEXT-PRIME-IMPLICANT-NODE" -> next-candidate
			 
			 ;; From bfig-conflicts.lisp
			 "CONFLICT"
;;;			 new-conflict
			 "INSERT-CONFLICT!"
			 "INSERT-NEW-CONFLICT"		
			 "REMOVE-ALL-CONFLICTS!"
			 
			 ;; From bfig-compare.lisp
			 "EQUAL-KERNELS"
			 "SET-CONTAINS-KERNEL"
			 "EQUAL-KERNEL-SETS"
			 "EQUAL-KERNEL-SEQUENCES"
			 "EQUAL-STATE-ASSIGNMENTS"
			 
			 )
			)
