;;;; Copyright (c) 2009 Massachusetts Institute of Technology

;;;; This software may not be redistributed, and can only be retained and used
;;;; with the explicit written consent of the author, subject to the following
;;;; conditions:

;;;; The above copyright notice and this permission notice shall be included in
;;;; all copies or substantial portions of the Software.

;;;; This software may only be used for non-commercial, non-profit, research
;;;; activities.

;;;; THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESSED
;;;; OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
;;;; FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
;;;; THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
;;;; LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
;;;; FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
;;;; DEALINGS IN THE SOFTWARE.

;;;; Authors:
;;;;   Seung H. Chung

(in-package :mtk-csp-tcsp-tcsp2dot)

;;; For references relating to this code see:
;;;   [1] R. Dechter. Constraint Processing. Morgan Kaufmann, San Francisco,
;;;   California, 2003.

(defmethod mtk-graph-graph2dot:dot-print-graph
    ((tcsp tcsp)
     &key
     (stream t)
     (vertex-labeler #'mtk-graph-graph2dot:dot-generate-vertex-label)
     (edge-labeler #'dot-generate-tcsp-edge-label)
     (rest tcsp))
  ;;(format t "TCSP dot-print-graph: ~A.~%" edge-labeler)
  (call-next-method 
   tcsp
   :stream stream
   :vertex-labeler vertex-labeler
   :edge-labeler edge-labeler
   :rest rest))

(defmethod dot-generate-tcsp-edge-label ((e_i mtk-graph:directed-edge)
					 &rest rest)
  ;;(format t "TCSP edge lable was called.")
  (let* ((tcsp (first rest))
	 (intervals (mtk-csp:get-relation 
		     (get-temporal-constraint e_i tcsp))))
    (reduce #'(lambda (x y) (format nil "~A \\n ~A" x y))
	    (mapcar #'interval-to-string intervals))))
