;;;; Copyright (c) 2009 Massachusetts Institute of Technology

;;;; This software may not be redistributed, and can only be retained and used
;;;; with the explicit written consent of the author, subject to the following
;;;; conditions:

;;;; The above copyright notice and this permission notice shall be included in
;;;; all copies or substantial portions of the Software.

;;;; This software may only be used for non-commercial, non-profit, research
;;;; activities.

;;;; THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESSED
;;;; OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
;;;; FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
;;;; THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
;;;; LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
;;;; FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
;;;; DEALINGS IN THE SOFTWARE.

;;;; Authors:
;;;;   Seung H. Chung

(in-package :mtk-csp)

;; For references relating to this code see:
;;   [1] R. Dechter. Constraint Processing. Morgan Kaufmann, San Francisco,
;;   California, 2003.


;;; From [1] pg. 30:
(defun generate-primal-constraint-graph-test-figure-2.3a ()
  (let ((v '(x1 x2 x3 x4 x5 x6))
	(s '((x1 x2) (x1 x3) (x4 x2) (x4 x3) (x5 x2) (x6 x4) (x6 x5))))
    (generate-primal-constraint-graph v s)))	

(defun generate-primal-constraint-graph-test-figure-2.3b ()
  (let ((v '(x1 x2 x3 x4))
	(s '((x1 x2) (x1 x3) (x1 x4) (x2 x3) (x2 x4) (x3 x4))))
    (generate-primal-constraint-graph v s)))
