;;;; Copyright (c) 2009 Massachusetts Institute of Technology

;;;; This software may not be redistributed, and can only be retained and used
;;;; with the explicit written consent of the author, subject to the following
;;;; conditions:

;;;; The above copyright notice and this permission notice shall be included in
;;;; all copies or substantial portions of the Software.

;;;; This software may only be used for non-commercial, non-profit, research
;;;; activities.

;;;; THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESSED
;;;; OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
;;;; FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
;;;; THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
;;;; LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
;;;; FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
;;;; DEALINGS IN THE SOFTWARE.

;;;; Authors:
;;;;   Patrick Conrad

(asdf:defsystem :Drake2
  :name "Drake2"
  :version "0.1"
  :description "MERS Toolkit: Drake2"
  :author "Patrick R. Conrad"
  :maintainer "MIT MERS Group"
  :serial t
  :components ((:file "package")
			   (:file "lstn-benchmarking") ;; defines macros used in benchmarking the implementation
			   (:file "test-labeled-distance-graph")
			   (:file "random-structured-ldg")
			   (:file "compile-labeled-distance-graph")
			   (:file "dispatch-ldg")
			   (:file "dispatch-ldg-online")
			   (:file "test-dispatch-ldg-online")
			   (:file "tpn-ldg-conversion")
			   (:file "test-tpn-ldg-conversion")
			   (:file "compute-ldg-span"
					  :depends-on ("package"))
			   (:file "test-compute-ldg-span"
					  :depends-on ("package" "compute-ldg-span"))
			   )
  :depends-on (#:mtk-utils
			   #:mtk-utils-infinity
			   #:mtk-graph
			   #:mtk-graph-algorithms
			   #:state-space
			   ;; for dispatch-ldg-online.lisp
			   #:mtk-utils-threading 
			   #:bordeaux-threads
			   ;; for tpn-ldg-conversion.lisp
			   #:tpn
			   #:abstract-data-types
			   ;; for compute-ldg-span.lisp
			   #:simplex))
