(in-package #:drake2)


(defmacro print-values (func)
  `(format t "~s~%" (multiple-value-list ,func)))

(defun test-compute-ldg-span ()
  (let*  (;; Create the labeled-weighted-directed graph
		  (var-descriptions '((a :domain ((1)(2)))))
		  (state-space (make-instance 'state-space-w-conflicts :variable-descriptions var-descriptions))
		  (graph (make-instance 'mtk-graph:labeled-weighted-directed-graph :state-space state-space))
		  ;; Create the data structure to hold onto activities
		  (activities (make-activities)))

	(insert-new-constraint graph activities :start 'a :end 'b :lb 1 :ub 2 :guard '((= a 2)) :primitive "a->b")
	(insert-new-constraint graph activities :start 'b :end 'c :lb 1.2 :ub 2 :guard '((= a 2)) :primitive "b->c")
	(insert-new-constraint graph activities :start 'a :end 'c :lb 1 :ub 3 :guard '((= a 2)) :primitive "a->c")

	(let ((env (get-clause-from-descriptions (get-state-space graph) '((= a 2))) ))

	  ;; Compute the ldg span
	  (print-values (compute-ldg-span graph 'a 'c :env env))

	  ;; Compile the graph into dispatchable form
	  (let* ((dispatchable-graph (construct-dispatchable-graph graph)))

	    ;; Compute the ldg span of the dispatchable form
	    (print-values (compute-ldg-span dispatchable-graph 'a 'c :env env))
	    )
	  )
	))
