(in-package :drake2)

;;;; In general, the test functions in here aren't useful. They do construct graphs, but they're
;;;; not hooked up to a test suite because I stopped developing them.

(defun insert (graph &key (start nil) (end nil) (lb 0) (ub 0) (guard nil) &allow-other-keys)
  (with-slots (state-space) graph
	(let ((lb-edge (list end start))
		  (ub-edge (list start end)))
	  (mtk-graph:add-weighted-edge 
	   `(,lb-edge 
		 ,(mtk-graph:make-labeled-value-set-from-description state-space 'mtk-graph:strict-labeled-value-set #'< #'eql `((,(- lb) ,guard)))) graph)
	  (mtk-graph:add-weighted-edge 
	   `(,ub-edge 
		 ,(mtk-graph:make-labeled-value-set-from-description state-space 'mtk-graph:strict-labeled-value-set #'< #'eql `((,ub ,guard)))) graph)
	  )))

(defun test-ldg-compilation ()

	   (let* ((var-descriptions
			   '((a :domain ((1) (2)))))
			  ;;create the state space
			  (state-space (make-instance 'state-space-w-conflicts :variable-descriptions var-descriptions))
			  (graph (make-instance 'mtk-graph:labeled-weighted-directed-graph
									:state-space state-space)))

		 (mtk-graph:add-weighted-edge `((a b) ,(mtk-graph:make-labeled-value-set-from-description state-space 'mtk-graph:strict-labeled-value-set #'< #'eql '((1 ((= a 1)))))) graph)
		 (mtk-graph:add-weighted-edge `((b c) ,(mtk-graph:make-labeled-value-set-from-description state-space 'mtk-graph:strict-labeled-value-set #'< #'eql '((1 ((= a 1)))))) graph)
		 (mtk-graph:add-weighted-edge `((a c) ,(mtk-graph:make-labeled-value-set-from-description state-space 'mtk-graph:strict-labeled-value-set #'< #'eql '((3 ((= a 1)))))) graph)


		 (mtk-graph:add-weighted-edge `((c a) ,(mtk-graph:make-labeled-value-set-from-description state-space 'mtk-graph:strict-labeled-value-set #'< #'eql '((-3 ((= a 2)))))) graph)
		 (mtk-graph:add-weighted-edge `((c b) ,(mtk-graph:make-labeled-value-set-from-description state-space 'mtk-graph:strict-labeled-value-set #'< #'eql '((-2 ((= a 2)))))) graph)
		 (mtk-graph:add-weighted-edge `((b a) ,(mtk-graph:make-labeled-value-set-from-description state-space 'mtk-graph:strict-labeled-value-set #'< #'eql '((-1 ((= a 2)))))) graph)
  
 
		 (let* ((sssp-c (bellman-ford graph 'c))
				(dispatchable-graph (construct-dispatchable-graph graph))
				(dispatcher (make-instance 'ldg-dispatch :start 'a 
										   :ldg dispatchable-graph)))

		   (offline-execute! dispatcher)

		   (format t "trace: ~a~%" (dispatch-trace dispatcher))
   
		   (format t "result: ~a~%" dispatchable-graph)
		   (loop for key being the hash-key of sssp-c
			  do (format t "~a ~a~%" key (gethash key sssp-c)))
		   )

		 ))

(defun test-ldg-compilation2 ()
	   (let* ((var-descriptions
			   '((a :domain ((1) (2)))))
			  ;;create the state space
			  (state-space (make-instance 'state-space-w-conflicts :variable-descriptions var-descriptions))
			  (graph (make-instance 'mtk-graph:labeled-weighted-directed-graph
									:state-space state-space)))

		 (mtk-graph:add-weighted-edge `((a b) ,(mtk-graph:make-labeled-value-set-from-description state-space 'mtk-graph:strict-labeled-value-set #'< #'eql '((2 ())))) graph)
		 (mtk-graph:add-weighted-edge `((b a) ,(mtk-graph:make-labeled-value-set-from-description state-space 'mtk-graph:strict-labeled-value-set #'< #'eql '((-1 ())))) graph)

		 (mtk-graph:add-weighted-edge `((b c) ,(mtk-graph:make-labeled-value-set-from-description state-space 'mtk-graph:strict-labeled-value-set #'< #'eql '((2 ())))) graph)
		 (mtk-graph:add-weighted-edge `((c b) ,(mtk-graph:make-labeled-value-set-from-description state-space 'mtk-graph:strict-labeled-value-set #'< #'eql '((-1 ())))) graph)
	
	 
		 (mtk-graph:add-weighted-edge `((a c) ,(mtk-graph:make-labeled-value-set-from-description state-space 'mtk-graph:strict-labeled-value-set #'< #'eql '((6 ((= a 2)))))) graph)
		 (mtk-graph:add-weighted-edge `((c a) ,(mtk-graph:make-labeled-value-set-from-description state-space 'mtk-graph:strict-labeled-value-set #'< #'eql '((-6 ((= a 2)))))) graph)

		 (mtk-graph:add-weighted-edge `((a c) ,(mtk-graph:make-labeled-value-set-from-description state-space 'mtk-graph:strict-labeled-value-set #'< #'eql '((5 ((= a 1)))))) graph)
		 (mtk-graph:add-weighted-edge `((c a) ,(mtk-graph:make-labeled-value-set-from-description state-space 'mtk-graph:strict-labeled-value-set #'< #'eql '((-5 ((= a 1)))))) graph)
 
		 (let* ((sssp-c (bellman-ford graph 'c))
				(dispatchable-graph (construct-dispatchable-graph graph))
				(dispatcher (make-instance 'ldg-dispatch :start 'a 
										   :ldg dispatchable-graph)))

		   (offline-execute! dispatcher)

		   (format t "trace: ~a~%" (dispatch-trace dispatcher))
   
		   (format t "result: ~a~%" dispatchable-graph)
		   (loop for key being the hash-key of sssp-c
			  do (format t "~a ~a~%" key (gethash key sssp-c)))
		   )
		 ))


(defun test-compilation-decimated-time ()
  (let*  (;; Create the labeled-weighted-directed graph
		  (var-descriptions '())
		  (state-space (make-instance 'state-space-w-conflicts :variable-descriptions var-descriptions))
		  (graph (make-instance 'mtk-graph:labeled-weighted-directed-graph :state-space state-space)))
	;; create a function to make adding constraints easier to read
	(insert graph :start 'start :end 'a :lb 0.0 :ub *inf* :guard '())
	(insert graph :start 'a :end 'b :lb 3.9237254 :ub 4.0792913 :guard '())
	(insert graph :start 'b :end 'end :lb 0.0 :ub *inf* :guard '())
	
	(insert graph :start 'b :end 'c :lb 0.0 :ub *inf* :guard '())
	
	(insert graph :start 'start :end 'c :lb 0.0 :ub *inf* :guard '())
	(insert graph :start 'c :end 'd :lb 0.0 :ub 0.0 :guard '())
	(insert graph :start 'd :end 'e :lb 3.923733 :ub 4.0792966 :guard '()) ;;; change the lowerbound 3.1 to a 3
	  
	(insert graph :start 'e :end 'end :lb 0.0 :ub *inf* :guard '())

	(let* ((sssp-end (bellman-ford graph 'end))
		   (dispatchable-graph (construct-dispatchable-graph graph)) )

		   (format t "result: ~a~%" dispatchable-graph)
		   (loop for key being the hash-key of sssp-end
			  do (format t "~a ~a~%" key (gethash key sssp-end)))
		   )
	))


(defun test-ldg-zero-compilation ()

	   (let* ((var-descriptions
			   '((a :domain ((2)))))
			  ;;create the state space
			  (state-space (make-instance 'state-space-w-conflicts :variable-descriptions var-descriptions))
			  (graph (make-instance 'mtk-graph:labeled-weighted-directed-graph
									:state-space state-space)))

		 (mtk-graph:add-weighted-edge `((a b) ,(mtk-graph:make-labeled-value-set-from-description state-space 'mtk-graph:strict-labeled-value-set #'< #'eql '((0 ((= a 2)))))) graph)
		 (mtk-graph:add-weighted-edge `((b c) ,(mtk-graph:make-labeled-value-set-from-description state-space 'mtk-graph:strict-labeled-value-set #'< #'eql '((2 ((= a 2)))))) graph)
		 (mtk-graph:add-weighted-edge `((a c) ,(mtk-graph:make-labeled-value-set-from-description state-space 'mtk-graph:strict-labeled-value-set #'< #'eql '((2 ((= a 2)))))) graph)


		 (mtk-graph:add-weighted-edge `((c a) ,(mtk-graph:make-labeled-value-set-from-description state-space 'mtk-graph:strict-labeled-value-set #'< #'eql '((-2 ((= a 2)))))) graph)
		 (mtk-graph:add-weighted-edge `((c b) ,(mtk-graph:make-labeled-value-set-from-description state-space 'mtk-graph:strict-labeled-value-set #'< #'eql '((-2 ((= a 2)))))) graph)
		 (mtk-graph:add-weighted-edge `((b a) ,(mtk-graph:make-labeled-value-set-from-description state-space 'mtk-graph:strict-labeled-value-set #'< #'eql '((0 ((= a 2)))))) graph)
  
 
		 (let* ((sssp-c (bellman-ford graph 'c))
				(dispatchable-graph (construct-dispatchable-graph graph))
				(dispatcher (make-instance 'ldg-dispatch :start 'a 
										   :ldg dispatchable-graph)))

		   (format t "result: ~a~%" dispatchable-graph)
		   (offline-execute! dispatcher)

		   (format t "trace: ~a~%" (dispatch-trace dispatcher))
   

		   (loop for key being the hash-key of sssp-c
			  do (format t "~a ~a~%" key (gethash key sssp-c)))
		   )

		 ))


(defun test-ldg-compilation-rigid ()

	   (let* ((var-descriptions
			   '((a :domain ((1) (2)))))
			  ;;create the state space
			  (state-space (make-instance 'state-space-w-conflicts :variable-descriptions var-descriptions))
			  (graph (make-instance 'mtk-graph:labeled-weighted-directed-graph
									:state-space state-space)))


		 (mtk-graph:add-weighted-edge `((a d) ,(mtk-graph:make-labeled-value-set-from-description state-space 'mtk-graph:strict-labeled-value-set #'< #'eql '((-2 ())))) graph)
		 (mtk-graph:add-weighted-edge `((d a) ,(mtk-graph:make-labeled-value-set-from-description state-space 'mtk-graph:strict-labeled-value-set #'< #'eql '((5 ())))) graph)

		 (mtk-graph:add-weighted-edge `((b c) ,(mtk-graph:make-labeled-value-set-from-description state-space 'mtk-graph:strict-labeled-value-set #'< #'eql '((-1 ())))) graph)
		 (mtk-graph:add-weighted-edge `((c b) ,(mtk-graph:make-labeled-value-set-from-description state-space 'mtk-graph:strict-labeled-value-set #'< #'eql '((1 ())))) graph)


		 (mtk-graph:add-weighted-edge `((c d) ,(mtk-graph:make-labeled-value-set-from-description state-space 'mtk-graph:strict-labeled-value-set #'< #'eql '((0 ())))) graph)
		 (mtk-graph:add-weighted-edge `((d c) ,(mtk-graph:make-labeled-value-set-from-description state-space 'mtk-graph:strict-labeled-value-set #'< #'eql '((0 ())))) graph)


		 (mtk-graph:add-weighted-edge `((b e) ,(mtk-graph:make-labeled-value-set-from-description state-space 'mtk-graph:strict-labeled-value-set #'< #'eql '((4 ())))) graph)
		 (mtk-graph:add-weighted-edge `((e b) ,(mtk-graph:make-labeled-value-set-from-description state-space 'mtk-graph:strict-labeled-value-set #'< #'eql '((-3 ())))) graph)

		 (mtk-graph:add-weighted-edge `((c e) ,(mtk-graph:make-labeled-value-set-from-description state-space 'mtk-graph:strict-labeled-value-set #'< #'eql '((5 ())))) graph)

		 (mtk-graph:add-weighted-edge `((a c) ,(mtk-graph:make-labeled-value-set-from-description state-space 'mtk-graph:strict-labeled-value-set #'< #'eql '((-2 ())))) graph)

		 (mtk-graph:add-weighted-edge `((a f) ,(mtk-graph:make-labeled-value-set-from-description state-space 'mtk-graph:strict-labeled-value-set #'< #'eql '((3 ((= a 1)))))) graph)
		 (mtk-graph:add-weighted-edge `((f a) ,(mtk-graph:make-labeled-value-set-from-description state-space 'mtk-graph:strict-labeled-value-set #'< #'eql '((-3 ((= a 1)))))) graph)



		 (debug-print-for :drake t "Input graph: ~a" graph)
  
  

		 (let* (
				(sssp-e (bellman-ford graph 'e :predecessor-graph? t))
	   
				(dispatchable-graph (construct-dispatchable-graph graph))
				(dispatcher (make-instance 'ldg-dispatch :start 'a 
										   :ldg dispatchable-graph))
				(rigid-components-ht (make-hash-table)))
  
										;(update-rigid-components! graph sssp-d rigid-components-ht)
										;(update-rigid-components! graph sssp-f rigid-components-ht)
										;(update-rigid-components! graph sssp-b rigid-components-ht)

										;(test '((b c d) (f a))  (gethash (get-clause-from-descriptions state-space '((= a 1))) 
										;								   rigid-components-ht)
										;		:test #'equalp)
  
										; (test '((d c b)) (gethash (get-clause-from-descriptions state-space '()) 
										;							rigid-components-ht)
										;		:test #'equalp)
  
										; (multiple-value-bind (member? leader?) 
										;	  (is-vertex-part-of-rigid-component? 
										;	   rigid-components-ht 'f 
										;	   (get-clause-from-descriptions state-space '()) )
										;	(test nil member?)
										;	(test nil leader?))
										;
										;(multiple-value-bind (member? leader?) 
										;	  (is-vertex-part-of-rigid-component? 
										;	   rigid-components-ht 'f
										;	   (get-clause-from-descriptions state-space '((= a 1))) )
										;	(test t member?)
										;	(test t leader?))

										;(multiple-value-bind (member? leader?) 
										;	  (is-vertex-part-of-rigid-component? 
										;	   rigid-components-ht 'c
										;	   (get-clause-from-descriptions state-space '()) )
										;	(test t member?)
										;	(test nil leader?))



		   (offline-execute! dispatcher)
  
		   (format t "trace: ~a~%" (dispatch-trace dispatcher)) 



   
		   (format t "result: ~a~%" dispatchable-graph)
		   (loop for key being the hash-key of sssp-e
			  do (format t "~a ~a~%" key (gethash key sssp-e)))

		   (format t "rigid:~%")
		   (loop for key being the hash-key of rigid-components-ht
			  do (format t "~a ~a~%" key (gethash key rigid-components-ht))))

		 ))

(defun test-ldg-compilation-rigid2 ()

	   (let* ((var-descriptions
			   '((a :domain ((1) (2)))))
			  ;;create the state space
			  (state-space (make-instance 'state-space-w-conflicts :variable-descriptions var-descriptions))
			  (graph (make-instance 'mtk-graph:labeled-weighted-directed-graph
									:state-space state-space)))


		 (mtk-graph:add-weighted-edge `((a c) ,(mtk-graph:make-labeled-value-set-from-description state-space 'mtk-graph:strict-labeled-value-set #'< #'eql '((1 ())))) graph)
		 (mtk-graph:add-weighted-edge `((c b) ,(mtk-graph:make-labeled-value-set-from-description state-space 'mtk-graph:strict-labeled-value-set #'< #'eql '((-8 ())))) graph)
		 (mtk-graph:add-weighted-edge `((b a) ,(mtk-graph:make-labeled-value-set-from-description state-space 'mtk-graph:strict-labeled-value-set #'< #'eql '((7 ())))) graph)
		 (mtk-graph:add-weighted-edge `((d a) ,(mtk-graph:make-labeled-value-set-from-description state-space 'mtk-graph:strict-labeled-value-set #'< #'eql '((-3 ())))) graph)
		 (mtk-graph:add-weighted-edge `((e d) ,(mtk-graph:make-labeled-value-set-from-description state-space 'mtk-graph:strict-labeled-value-set #'< #'eql '((2 ((= a 1)))))) graph)
		 (mtk-graph:add-weighted-edge `((d e) ,(mtk-graph:make-labeled-value-set-from-description state-space 'mtk-graph:strict-labeled-value-set #'< #'eql '((-1 ((= a 1)))))) graph)




		 (debug-print-for :drake t "Input graph: ~a" graph)
  
  

		 (let* (
				(sssp-d (bellman-ford graph 'd :predecessor-graph? t))
	   
				(dispatchable-graph (construct-dispatchable-graph graph))
				(dispatcher (make-instance 'ldg-dispatch :start 'a 
										   :ldg dispatchable-graph))
				(rigid-components-ht (make-hash-table)))
  

		   (test '((b c d) (f a))  (gethash (get-clause-from-descriptions state-space '((= a 1))) 
											rigid-components-ht)
				 :test #'equalp)
  
		   (test '((d c b)) (gethash (get-clause-from-descriptions state-space '()) 
									 rigid-components-ht)
				 :test #'equalp)
  



		   (offline-execute! dispatcher)
		   (format t "result: ~a~%" dispatchable-graph)  
		   (format t "trace: ~a~%" (dispatch-trace dispatcher)) 


   

		   (loop for key being the hash-key of sssp-d
			  do (format t "~a ~a~%" key (gethash key sssp-d)))

		   (format t "rigid:~%")
		   (loop for key being the hash-key of rigid-components-ht
			  do (format t "~a ~a~%" key (gethash key rigid-components-ht))))

		 ))



(defun test-compilation-disconnected ()

	   (let* ((var-descriptions
			   '((a :domain ((1) (2)))))
			  ;;create the state space
			  (state-space (make-instance 'state-space-w-conflicts :variable-descriptions var-descriptions))
			  (graph (make-instance 'mtk-graph:labeled-weighted-directed-graph
									:state-space state-space)))

		 (mtk-graph:add-weighted-edge `((a d) ,(mtk-graph:make-labeled-value-set-from-description state-space 'mtk-graph:strict-labeled-value-set #'< #'eql '((-2 ())))) graph)
		 (mtk-graph:add-weighted-edge `((d a) ,(mtk-graph:make-labeled-value-set-from-description state-space 'mtk-graph:strict-labeled-value-set #'< #'eql '((5 ())))) graph)

		 (mtk-graph:add-weighted-edge `((b c) ,(mtk-graph:make-labeled-value-set-from-description state-space 'mtk-graph:strict-labeled-value-set #'< #'eql '((-1 ())))) graph)
		 (mtk-graph:add-weighted-edge `((c b) ,(mtk-graph:make-labeled-value-set-from-description state-space 'mtk-graph:strict-labeled-value-set #'< #'eql '((1 ())))) graph)
  
  

		 (let* ((sssp-c (bellman-ford graph 'f :predecessor-graph? t))
				(dispatchable-graph (construct-dispatchable-graph graph))
				(dispatcher (make-instance 'ldg-dispatch :start 'a 
										   :ldg dispatchable-graph)))

		   (offline-execute! dispatcher)

		   (format t "trace: ~a ~%" (dispatch-trace dispatcher) )

	
   
		   (format t "result: ~a~%" dispatchable-graph)
		   (loop for key being the hash-key of sssp-c
			  do (format t "~a ~a~%" key (gethash key sssp-c)))
		   )

		 ))


(defun test-compilation-rigid-complex ()

	   (let* ((var-descriptions
			   '((a :domain ((1)))
				 (b :domain ((1)))))
			  ;;create the state space
			  (state-space (make-instance 'state-space-w-conflicts :variable-descriptions var-descriptions))
			  (graph (make-instance 'mtk-graph:labeled-weighted-directed-graph
									:state-space state-space)))

		 (mtk-graph:add-weighted-edge `((a b) ,(mtk-graph:make-labeled-value-set-from-description state-space 'mtk-graph:strict-labeled-value-set #'< #'eql '((0 ())))) graph)

		 (mtk-graph:add-weighted-edge `((b c) ,(mtk-graph:make-labeled-value-set-from-description state-space 'mtk-graph:strict-labeled-value-set #'< #'eql '((0 ((= a 1)))))) graph)

		 (mtk-graph:add-weighted-edge `((c a) ,(mtk-graph:make-labeled-value-set-from-description state-space 'mtk-graph:strict-labeled-value-set #'< #'eql '((0 ((= b 1)))))) graph)

		 (mtk-graph:add-weighted-edge `((b a) ,(mtk-graph:make-labeled-value-set-from-description state-space 'mtk-graph:strict-labeled-value-set #'< #'eql '((0 ((= b 1) (= a 1)))))) graph)

		 (mtk-graph:add-weighted-edge `((c b) ,(mtk-graph:make-labeled-value-set-from-description state-space 'mtk-graph:strict-labeled-value-set #'< #'eql '((0 ())))) graph)

		 (mtk-graph:add-weighted-edge `((d a) ,(mtk-graph:make-labeled-value-set-from-description state-space 'mtk-graph:strict-labeled-value-set #'< #'eql '((-1 ((= a 1) (= b 1)))))) graph)
		 (mtk-graph:add-weighted-edge `((d b) ,(mtk-graph:make-labeled-value-set-from-description state-space 'mtk-graph:strict-labeled-value-set #'< #'eql '((-1 ((= a 1) (= b 1)))))) graph)


		 (let* ((sssp-c (bellman-ford graph 'f :predecessor-graph? t))
				(dispatchable-graph (construct-dispatchable-graph graph))
				(dispatcher (make-instance 'ldg-dispatch :start 'a 
										   :ldg dispatchable-graph)))

		   (break)
		   (offline-execute! dispatcher)

		   (format t "trace: ~a~%" (dispatch-trace dispatcher) 
	)

	
   
		   (format t "result: ~a~%" dispatchable-graph)
		   (loop for key being the hash-key of sssp-c
			  do (format t "~a ~a~%" key (gethash key sssp-c)))
		   )

		 ))

(defun test-compilation-small-prune ()

  (let* ((var-descriptions
		  '((a :domain ((1) (2)))))
		 ;;create the state space
		 (state-space (make-instance 'state-space-w-conflicts :variable-descriptions var-descriptions))
		 (graph (make-instance 'mtk-graph:labeled-weighted-directed-graph
							   :state-space state-space)))

	(mtk-graph:add-weighted-edge `((a b) ,(mtk-graph:make-labeled-value-set-from-description state-space 'mtk-graph:strict-labeled-value-set #'< #'eql '((1 ())))) graph)
	(mtk-graph:add-weighted-edge `((a c) ,(mtk-graph:make-labeled-value-set-from-description state-space 'mtk-graph:strict-labeled-value-set #'< #'eql '((2 ())))) graph)
	(mtk-graph:add-weighted-edge `((b c) ,(mtk-graph:make-labeled-value-set-from-description state-space 'mtk-graph:strict-labeled-value-set #'< #'eql '((1 ())))) graph)
	(mtk-graph:add-weighted-edge `((a d) ,(mtk-graph:make-labeled-value-set-from-description state-space 'mtk-graph:strict-labeled-value-set #'< #'eql '((0 ())))) graph)
	(mtk-graph:add-weighted-edge `((d a) ,(mtk-graph:make-labeled-value-set-from-description state-space 'mtk-graph:strict-labeled-value-set #'< #'eql '((0 ())))) graph)
	(mtk-graph:add-weighted-edge `((d e) ,(mtk-graph:make-labeled-value-set-from-description state-space 'mtk-graph:strict-labeled-value-set #'< #'eql '((-1 ())))) graph)
	(mtk-graph:add-weighted-edge `((e f) ,(mtk-graph:make-labeled-value-set-from-description state-space 'mtk-graph:strict-labeled-value-set #'< #'eql '((-1 ())))) graph)
	(mtk-graph:add-weighted-edge `((d f) ,(mtk-graph:make-labeled-value-set-from-description state-space 'mtk-graph:strict-labeled-value-set #'< #'eql '((-2 ())))) graph)
  
  

	(let* ((sssp-c (bellman-ford graph 'a :predecessor-graph? t))
		   (dispatchable-graph (construct-dispatchable-graph graph))
		   (dispatcher (make-instance 'ldg-dispatch :start 'a 
									  :ldg dispatchable-graph)))
	  (format t "result: ~a~%" dispatchable-graph)
	  (offline-execute! dispatcher)

	  (format t "trace: ~a~%" (dispatch-trace dispatcher) 
)
	
   

	  (loop for key being the hash-key of sssp-c
		 do (format t "~a ~a~%" key (gethash key sssp-c)))
	  )

	))

(defun test-preprocess  ()
  
  (let* ((var-descriptions
		  '((a :domain ((1) (2)))))
		 ;;create the state space
		 (state-space (make-instance 'state-space-w-conflicts :variable-descriptions var-descriptions))
		 (graph (make-instance 'mtk-graph:labeled-weighted-directed-graph
							   :state-space state-space)))
	

	(mtk-graph:add-weighted-edge `((a c) ,(mtk-graph:make-labeled-value-set-from-description state-space 'mtk-graph:strict-labeled-value-set #'< #'eql '((1 ())))) graph)
	(mtk-graph:add-weighted-edge `((c b) ,(mtk-graph:make-labeled-value-set-from-description state-space 'mtk-graph:strict-labeled-value-set #'< #'eql '((-8 ())))) graph)
	(mtk-graph:add-weighted-edge `((b a) ,(mtk-graph:make-labeled-value-set-from-description state-space 'mtk-graph:strict-labeled-value-set #'< #'eql '((7 ())))) graph)
	(mtk-graph:add-weighted-edge `((d a) ,(mtk-graph:make-labeled-value-set-from-description state-space 'mtk-graph:strict-labeled-value-set #'< #'eql '((-3 ())))) graph)
	(mtk-graph:add-weighted-edge `((e d) ,(mtk-graph:make-labeled-value-set-from-description state-space 'mtk-graph:strict-labeled-value-set #'< #'eql '((2 ((= a 1)))))) graph)
	(mtk-graph:add-weighted-edge `((d e) ,(mtk-graph:make-labeled-value-set-from-description state-space 'mtk-graph:strict-labeled-value-set #'< #'eql '((-1 ((= a 1)))))) graph)
	
	(debug-print-for :drake t "Input graph: ~a" graph)
	
	))



;;****************************************************************************


(defun try-random ()
;;there's two find rigid component functions - make sure we've got the 
;;right one commented out!
  (let ((new? t))
	(loop for order from 2 to 2
	   do
	   (loop for choices from 5 to 5
		  do 	 
		  (loop for size from 5 to 5
			 do		  
			 (loop for j from 1 to 10
				with success?
				do
				(org.tfeb.hax.memoize:clear-memoized-functions) ;;clear the memos
				(format t "new problem ~a ~a ~a ~a~%"
						order choices size j)
				(multiple-value-bind (random-ldg constraints) 
					(random-structured-ldg 
					 size choices order 
					 4 10 20 (* 4 size) 
					 (* 8 size) (* 8 size)
					 (* 5 size) new? t)
				  (debug-print-for :drake t "problem: ~a~%" random-ldg)
				  ;; (mtk-graph-graph2dot::dot-print-weighted-graph
				  ;;  random-ldg (get-weight-ht-edge random-ldg) )
				  (handler-case 
					  (let* ((compiled-ldg (construct-dispatchable-graph 
											random-ldg))
								   
								   
							 (dispatcher (make-instance 'ldg-dispatch :ldg compiled-ldg))
							 )
							  
							  
						(debug-print-for :drake t "Compiled: ~a" compiled-ldg)
							  

(compute-size-of-ldg compiled-ldg)
			
						(offline-execute! dispatcher)
						(debug-print-for :drake t "first-print-trace: ~a~%" (dispatch-trace dispatcher))
						;;  (format t "~a~% ~a~%" random-ldg compiled-ldg)
						;; (break)
						(setf success? (execution-trace-valid? compiled-ldg constraints (dispatch-trace dispatcher)))
						(assert success?)
							  
						(format t "trace: ~a ~a~%" (dispatch-trace dispatcher) success?)
						;; (format t "constraints: ~a~%" constraints)
						)
						  
					(mtk-graph-algorithms::infeasible-problem ()
					  (format t "bad problem~%")
				   
					  (setf success? t))))
	   
	   
				always success?)))))
  )


(defun test-compilation-large-ldg ()
  (let*  (;; Create the labeled-weighted-directed graph
		  (var-descriptions '())
		  (state-space (make-instance 'state-space-w-conflicts :variable-descriptions var-descriptions))
		  (graph (make-instance 'mtk-graph:labeled-weighted-directed-graph :state-space state-space)))

	(insert graph :start '4START :end '4ENDNODE :lb 1.0E-4 :ub 588 :guard '())
	(insert graph :start '4START :end '4REALSTART :lb 0 :ub 0 :guard '())
	(insert graph :start '4REALSTART :end '4POSTFLY :lb 3 :ub *inf* :guard '())
	(insert graph :start '4POSTFLY :end '4CIRCLE :lb 1.0E-4 :ub *inf* :guard '())
	(insert graph :start '4CIRCLE :end '4ENDNODE :lb 1.0E-4 :ub 1 :guard '())
	(insert graph :start '4REALSTART :end '4SENSORSETUP :lb 0 :ub 0 :guard '())
	(insert graph :start '4SENSORSETUP :end '4SETMODE :lb 1.0E-4 :ub 1 :guard '())
	(insert graph :start '4SETMODE :end '4CAMERAREADY :lb 1.0E-4 :ub *inf* :guard '())
	(insert graph :start '4SENSORSETUP :end '4LOOKAT :lb 1.0E-4 :ub 1 :guard '())
	(insert graph :start '4LOOKAT :end '4CAMERAREADY :lb 1.0E-4 :ub *inf* :guard '())
	(insert graph :start '4CAMERAREADY :end '4CIRCLE :lb 1.0E-4 :ub *inf* :guard '())
	(insert graph :start 'master_start :end '4noop :lb 1.0E-4 :ub *inf* :guard '())
	(insert graph :start '4noop :end '4START :lb 0 :ub 0 :guard '())
	(insert graph :start '4ENDNODE :end '4noopend :lb 0 :ub 0 :guard '())
	(insert graph :start '4noopend :end 'master_end :lb 1.0E-4 :ub *inf* :guard '())
	(insert graph :start '4noopend :end '5noop :lb 1.0E-4 :ub *inf* :guard '())

	(insert graph :start '5START :end '5ENDNODE :lb 1.0E-4 :ub 588 :guard '())
	(insert graph :start '5START :end '5REALSTART :lb 0 :ub 0 :guard '())
	(insert graph :start '5REALSTART :end '5POSTFLY :lb 3 :ub *inf* :guard '())
	(insert graph :start '5POSTFLY :end '5CIRCLE :lb 1.0E-4 :ub *inf* :guard '())
	(insert graph :start '5CIRCLE :end '5ENDNODE :lb 1.0E-4 :ub 1 :guard '())
	(insert graph :start '5REALSTART :end '5SENSORSETUP :lb 3 :ub 20 :guard '())
	(insert graph :start '5SENSORSETUP :end '5SETMODE :lb 1.0E-4 :ub 1 :guard '())
	(insert graph :start '5SETMODE :end '5CAMERAREADY :lb 1.0E-4 :ub *inf* :guard '())
	(insert graph :start '5SENSORSETUP :end '5LOOKAT :lb 1.0E-4 :ub 1 :guard '())
	(insert graph :start '5LOOKAT :end '5CAMERAREADY :lb 1.0E-4 :ub *inf* :guard '())
	(insert graph :start '5CAMERAREADY :end '5CIRCLE :lb 1.0E-4 :ub *inf* :guard '())
	(insert graph :start 'master_start :end '5noop :lb 1.0E-4 :ub *inf* :guard '())
	(insert graph :start '5noop :end '5START :lb 5979/1000 :ub 5979/1000 :guard '())
	(insert graph :start '5ENDNODE :end '5noopend :lb 0 :ub 0 :guard '())
	(insert graph :start '5noopend :end 'master_end :lb 1.0E-4 :ub *inf* :guard '())
	(insert graph :start '5REALSTART :end '5POSTFLY :lb 5.885595 :ub 6.1189446 :guard '())
	(insert graph :start '5noopend :end '6noop :lb 1.0E-4 :ub *inf* :guard '())

	(insert graph :start '6START :end '6ENDNODE :lb 1.0E-4 :ub 588 :guard '())
	(insert graph :start '6START :end '6REALSTART :lb 0 :ub 0 :guard '())
	(insert graph :start '6REALSTART :end '6POSTFLY :lb 3 :ub *inf* :guard '())
	(insert graph :start '6POSTFLY :end '6CIRCLE :lb 1.0E-4 :ub *inf* :guard '())
	(insert graph :start '6CIRCLE :end '6ENDNODE :lb 1.0E-4 :ub 1 :guard '())
	(insert graph :start '6REALSTART :end '6SENSORSETUP :lb 3 :ub 20 :guard '())
	(insert graph :start '6SENSORSETUP :end '6SETMODE :lb 1.0E-4 :ub 1 :guard '())
	(insert graph :start '6SETMODE :end '6CAMERAREADY :lb 1.0E-4 :ub *inf* :guard '())
	(insert graph :start '6SENSORSETUP :end '6LOOKAT :lb 1.0E-4 :ub 1 :guard '())
	(insert graph :start '6LOOKAT :end '6CAMERAREADY :lb 1.0E-4 :ub *inf* :guard '())
	(insert graph :start '6CAMERAREADY :end '6CIRCLE :lb 1.0E-4 :ub *inf* :guard '())
	(insert graph :start 'master_start :end '6noop :lb 1.0E-4 :ub *inf* :guard '())
	(insert graph :start '6noop :end '6START :lb 4997/1000 :ub 4997/1000 :guard '())
	(insert graph :start '6ENDNODE :end '6noopend :lb 0 :ub 0 :guard '())
	(insert graph :start '6noopend :end 'master_end :lb 1.0E-4 :ub *inf* :guard '())
	(insert graph :start '6REALSTART :end '6POSTFLY :lb 5.885595 :ub 6.1189446 :guard '())
	(insert graph :start '6noopend :end '7noop :lb 1.0E-4 :ub *inf* :guard '())

	(insert graph :start '7START :end '7ENDNODE :lb 1.0E-4 :ub 588 :guard '())
	(insert graph :start '7START :end '7REALSTART :lb 0 :ub 0 :guard '())
	(insert graph :start '7REALSTART :end '7POSTFLY :lb 3 :ub *inf* :guard '())
	(insert graph :start '7POSTFLY :end '7CIRCLE :lb 1.0E-4 :ub *inf* :guard '())
	(insert graph :start '7CIRCLE :end '7ENDNODE :lb 1.0E-4 :ub 1 :guard '())
	(insert graph :start '7REALSTART :end '7SENSORSETUP :lb 3 :ub 20 :guard '())
	(insert graph :start '7SENSORSETUP :end '7SETMODE :lb 1.0E-4 :ub 1 :guard '())
	(insert graph :start '7SETMODE :end '7CAMERAREADY :lb 1.0E-4 :ub *inf* :guard '())
	(insert graph :start '7SENSORSETUP :end '7LOOKAT :lb 1.0E-4 :ub 1 :guard '())
	(insert graph :start '7LOOKAT :end '7CAMERAREADY :lb 1.0E-4 :ub *inf* :guard '())
	(insert graph :start '7CAMERAREADY :end '7CIRCLE :lb 1.0E-4 :ub *inf* :guard '())
	(insert graph :start 'master_start :end '7noop :lb 1.0E-4 :ub *inf* :guard '())
	(insert graph :start '7noop :end '7START :lb 997/500 :ub 997/500 :guard '())
	(insert graph :start '7ENDNODE :end '7noopend :lb 0 :ub 0 :guard '())
	(insert graph :start '7noopend :end 'master_end :lb 1.0E-4 :ub *inf* :guard '())
	(insert graph :start '7REALSTART :end '7POSTFLY :lb 5.885595 :ub 6.1189446 :guard '())
	(insert graph :start '7noopend :end '8noop :lb 1.0E-4 :ub *inf* :guard '())

	(insert graph :start '8START :end '8ENDNODE :lb 1.0E-4 :ub 588 :guard '())
	(insert graph :start '8START :end '8REALSTART :lb 0 :ub 0 :guard '())
	(insert graph :start '8REALSTART :end '8POSTFLY :lb 3 :ub *inf* :guard '())
	(insert graph :start '8POSTFLY :end '8CIRCLE :lb 1.0E-4 :ub *inf* :guard '())
	(insert graph :start '8CIRCLE :end '8ENDNODE :lb 1.0E-4 :ub 1 :guard '())
	(insert graph :start '8REALSTART :end '8SENSORSETUP :lb 3 :ub 20 :guard '())
	(insert graph :start '8SENSORSETUP :end '8SETMODE :lb 1.0E-4 :ub 1 :guard '())
	(insert graph :start '8SETMODE :end '8CAMERAREADY :lb 1.0E-4 :ub *inf* :guard '())
	(insert graph :start '8SENSORSETUP :end '8LOOKAT :lb 1.0E-4 :ub 1 :guard '())
	(insert graph :start '8LOOKAT :end '8CAMERAREADY :lb 1.0E-4 :ub *inf* :guard '())
	(insert graph :start '8CAMERAREADY :end '8CIRCLE :lb 1.0E-4 :ub *inf* :guard '())
	(insert graph :start 'master_start :end '8noop :lb 1.0E-4 :ub *inf* :guard '())
	(insert graph :start '8noop :end '8START :lb 0 :ub 0 :guard '())
	(insert graph :start '8ENDNODE :end '8noopend :lb 0 :ub 0 :guard '())
	(insert graph :start '8noopend :end 'master_end :lb 1.0E-4 :ub *inf* :guard '())
	(insert graph :start '8REALSTART :end '8POSTFLY :lb 5.885595 :ub 6.1189446 :guard '())
	(insert graph :start '8noopend :end '9noop :lb 1.0E-4 :ub *inf* :guard '())

	(insert graph :start '9START :end '9ENDNODE :lb 1.0E-4 :ub 588 :guard '())
	(insert graph :start '9START :end '9REALSTART :lb 0 :ub 0 :guard '())
	(insert graph :start '9REALSTART :end '9POSTFLY :lb 3 :ub *inf* :guard '())
	(insert graph :start '9POSTFLY :end '9CIRCLE :lb 1.0E-4 :ub *inf* :guard '())
	(insert graph :start '9CIRCLE :end '9ENDNODE :lb 1.0E-4 :ub 1 :guard '())
	(insert graph :start '9REALSTART :end '9SENSORSETUP :lb 3 :ub 20 :guard '())
	(insert graph :start '9SENSORSETUP :end '9SETMODE :lb 1.0E-4 :ub 1 :guard '())
	(insert graph :start '9SETMODE :end '9CAMERAREADY :lb 1.0E-4 :ub *inf* :guard '())
	(insert graph :start '9SENSORSETUP :end '9LOOKAT :lb 1.0E-4 :ub 1 :guard '())
	(insert graph :start '9LOOKAT :end '9CAMERAREADY :lb 1.0E-4 :ub *inf* :guard '())
	(insert graph :start '9CAMERAREADY :end '9CIRCLE :lb 1.0E-4 :ub *inf* :guard '())
	(insert graph :start 'master_start :end '9noop :lb 1.0E-4 :ub *inf* :guard '())
	(insert graph :start '9noop :end '9START :lb 0 :ub 0 :guard '())
	(insert graph :start '9ENDNODE :end '9noopend :lb 0 :ub 0 :guard '())
	(insert graph :start '9noopend :end 'master_end :lb 1.0E-4 :ub *inf* :guard '())
	(insert graph :start '9REALSTART :end '9POSTFLY :lb 5.885595 :ub 6.1189446 :guard '())

	(timing
	  (let* ((sssp-end (bellman-ford graph 'master_end))
			 (dispatchable-graph (construct-dispatchable-graph graph)) )
		(format t "result: ~a~%" dispatchable-graph)
		(loop for key being the hash-key of sssp-end
		   do (format t "~a ~a~%" key (gethash key sssp-end)))
		)
	  )
	))