;;;; Copyright (c) 2009 Massachusetts Institute of Technology

;;;; This software may not be redistributed, and can only be retained and used
;;;; with the explicit written consent of the author, subject to the following
;;;; conditions:

;;;; The above copyright notice and this permission notice shall be included in
;;;; all copies or substantial portions of the Software.

;;;; This software may only be used for non-commercial, non-profit, research
;;;; activities.

;;;; THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESSED
;;;; OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
;;;; FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
;;;; THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
;;;; LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
;;;; FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
;;;; DEALINGS IN THE SOFTWARE.

;;;; Authors:
;;;;   Seung H. Chung

(asdf:defsystem :mtk-graph-algorithms
  :name "mtk-graph-algorithms"
  :version "0.1"
  :description "MERS Toolkit: Graph Algorithms"
  :author "Seung H. Chung"
  :maintainer "MIT MERS Group"
;  :depends-on (:mtk-graph)
  :serial t
  :components ((:file "package")
               (:file "breadth-first-search"
					  :depends-on ("package"))
			   (:file "breadth-first-search-test"
					  :depends-on ("breadth-first-search"))
			   (:file "depth-first-search"
					  :depends-on ("package"))
			   (:file "depth-first-search-test"
					  :depends-on ("depth-first-search"))
			   (:file "topological-sort"
					  :depends-on ("depth-first-search"))
			   (:file "topological-sort-test"
					  :depends-on ("topological-sort"))
			   (:file "topological-sorts-enumerate-all"
					  :depends-on ("package"))
			   (:file "topological-sorts-enumerate-all-test"
					  :depends-on ("topological-sorts-enumerate-all"))
			   (:file "strongly-connected-components"
					  :depends-on ("depth-first-search"))
			   (:file "strongly-connected-components-test"
					  :depends-on ("strongly-connected-components"))
			   (:file "all-pairs-shortest-paths"
					  :depends-on ("package"))
			   (:file "all-pairs-shortest-paths-test"
					  :depends-on ("all-pairs-shortest-paths"))
			   (:file "single-source-shortest-path"
					  :depends-on ("package"))
			   (:file "test-labeled-algorithms"
					  :depends-on ("single-source-shortest-path"
								   "all-pairs-shortest-paths")))
  :depends-on (:mtk-graph))
