;; Tests topological-sorts-enumerate-all.lisp
;;
;; Author: Steve Levine (sjlevine@mit.edu)

(in-package :mtk-graph-algorithms)

(defmethod test-top-sorts-all-1 ()
  ;; Create a directed acyclic graph (DAG)
  (let* ((g (make-top-test-dag-1)))

	;; Enumerate all possible toplogical sorts
	;; and print them out
	(topological-sorts-all g))
)

(defmethod make-top-test-dag-1 ()
  (let* ((g (make-instance 'directed-graph))
		 (vertices `(a1 a2 b1 b2))
		 (edges `((a1 a2) (b1 b2))))
	(add-vertices vertices g)
	(add-edges edges g)
	g))