;;;; Copyright (c) 2009 Massachusetts Institute of Technology

;;;; This software may not be redistributed, and can only be retained and used
;;;; with the explicit written consent of the author, subject to the following
;;;; conditions:

;;;; The above copyright notice and this permission notice shall be included in
;;;; all copies or substantial portions of the Software.

;;;; This software may only be used for non-commercial, non-profit, research
;;;; activities.

;;;; THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESSED
;;;; OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
;;;; FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
;;;; THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
;;;; LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
;;;; FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
;;;; DEALINGS IN THE SOFTWARE.

;;;; Authors:
;;;;   Seung H. Chung

(in-package :mtk-graph-graph2dot)

(defun graph2dot-test ()
  (let ((e-list '((1 2) (1 3) (1 5) (2 4) (2 5) (3 4) (4 6)))
	 (g (make-instance 'mtk-graph:graph)))
    (mtk-graph:add-edges e-list g)
    (dot-print-graph g)
    (dot-graph g "test1.ps"))
  (let* ((e-list '((a b) (a c) (a e) (b d) (b e) (c d) (d f)))
	 (g (make-instance 'mtk-graph:directed-graph)))
    (mtk-graph:add-edges e-list g)
    (dot-print-graph g)
    (dot-graph g "test2.ps")))

(defun generate-graph-from-figure-22.3 ()
  (let* ((e '((r s) (r v) (s w) (t u) (t w) (t x) (u x) (u y) (w x) (x y)))
	 (g (make-instance 'mtk-graph:graph)))
    (mtk-graph:add-edges e g)
    g))

  