;;;; Copyright (c) 2009 Massachusetts Institute of Technology

;;;; This software may not be redistributed, and can only be retained and used
;;;; with the explicit written consent of the author, subject to the following
;;;; conditions:

;;;; The above copyright notice and this permission notice shall be included in
;;;; all copies or substantial portions of the Software.

;;;; This software may only be used for non-commercial, non-profit, research
;;;; activities.

;;;; THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESSED
;;;; OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
;;;; FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
;;;; THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
;;;; LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
;;;; FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
;;;; DEALINGS IN THE SOFTWARE.

;;;; Authors:
;;;;   Seung H. Chung, David Wang

(asdf:defsystem "mtk-graph"
  :name "mtk-graph"
  :version "0.1"
  :description "MERS Toolkit: Graph"
  :author "Seung H. Chung"
  :maintainer "MIT MERS Group"
  :components ((:file "package")
               (:file "hyper-graph"          :depends-on ("package"))
			   ;; (:file "hyper-graph2"          :depends-on ("package"))
               (:file "directed-hyper-graph" :depends-on ("hyper-graph"))
               (:file "graph"                :depends-on ("hyper-graph"))
			   (:file "directed-graph"       :depends-on ("graph"
                                                          "directed-hyper-graph"))
			   (:file "graph-test"           :depends-on ("hyper-graph"
                                                          "directed-hyper-graph"
                                                          "graph"
                                                          "directed-graph"))

			   (:file "weighted-graph"      :depends-on ("hyper-graph"
                                                         "directed-hyper-graph"
                                                         "graph"
                                                         "directed-graph"))
			   (:file "weighted-graph-test" :depends-on ("weighted-graph"))

               (:file "labeled-value-set"      :depends-on ("package"))
			   (:file "labeled-value-set-test" :depends-on ("labeled-value-set"))
			   (:file "labeled-directed-graph" :depends-on ("directed-graph"))
			   (:file "labeled-distance-graph" :depends-on ("directed-graph"
                                                            "weighted-graph"))
)
  :depends-on ("mtk-utils-infinity"
               "state-space"
			   "abstract-data-types"))
