;;; -*- Mode:Common-Lisp; Package:COMMON-LISP-USER; Base:10 -*-

;;; Copyright (c) 1999 - 2009 Brian C. Williams, MIT.

;;; This software may not be redistributed, and can only be retained
;;; and used with the explicit written consent of the author,
;;; Brian C. Williams.

;;; This software is made available as is; no guarantee is provided
;;; with respect to performance or correct behavior.

;;; This software may only be used for non-commercial, non-profit,
;;; research activities.

(in-package :COMMON-LISP-USER)

;;; This version of ISAT includes dynamic backtracking.
(asdf:defsystem #:isat
  :name "ISAT"
  :version "0.1"
  :description "MERS Toolkit: Incremental Satisfiability"
  :author "MERS Group"
  :maintainer "MIT MERS Group"
  :serial t
  :components(
  
			  (:file "package") 
			  (:file "heap")
			  (:file "linked-hashset")
			  (:file "propositional-theories")
			  
			  (:file "prop-theory-manipulation")
			  (:file "model-finding-defs")
			  (:file "unit-propagation")
			  (:file "conflicts")
			  (:file "development")
			  (:file "model-finding")
			  (:file "consistency")
			  (:file "tests")
			  (:file "test-isat-nqueens"))

 :depends-on (#:mtk-utils
			  #:constraint-system)	
)
