;;;; Copyright (c) 2008-2010 Brian C. Williams, MIT.

;;;; This software may not be redistributed, and can only be retained and used
;;;; with the explicit written consent of the authors, subject to the following
;;;; conditions:

;;;; The above copyright notice and this permission notice shall be included in
;;;; all copies or substantial portions of the Software.

;;;; This software may only be used for non-commercial, non-profit, research
;;;; activities.

;;;; THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESSED
;;;; OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
;;;; FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
;;;; THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
;;;; LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
;;;; FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
;;;; DEALINGS IN THE SOFTWARE.


(asdf:defsystem #:ITC
  :name #:ITC
  :version "0.1"
  :description "MERS Toolkit: Incremental Temporal Consistency"
  :author "Brian C. Williams (ITC, conditional ITC) and 
           Patrick R. Conrad (dispatching)"
  :maintainer "MIT MERS Group"
  :serial t
  :components ((:file "package")
			   (:file "stn-defs") 
			   (:file "itc-stn-defs")
			   (:file "ltnp-defs")
			   (:file "manipulate-stn")
			   (:file "manipulate-itc-stn")
			   (:file "manipulate-ltnp")			   
			   (:file "stn-reasoning")
			   (:file "dispatch-stn")
			   (:file "propagate-ub")
			   (:file "propagate-lb")
			   (:file "conflicts")
			   (:file "consistency")

			   (:file "tests")
			   (:file "test-stn")
			   (:file "test-itc-stn-explanation")

               )
   :depends-on (#:mtk-utils
				#:mtk-utils-infinity
				#:state-space
				#:constraint-system
				#:abstract-data-types
				#:temporal-constraints
				#:metacopy
				)
)
