;;;; Copyright (c) 2008-2010 Brian C. Williams, MIT.

;;;; This software may not be redistributed, and can only be retained and used
;;;; with the explicit written consent of the authors, subject to the following
;;;; conditions:

;;;; The above copyright notice and this permission notice shall be included in
;;;; all copies or substantial portions of the Software.

;;;; This software may only be used for non-commercial, non-profit, research
;;;; activities.

;;;; THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESSED
;;;; OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
;;;; FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
;;;; THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
;;;; LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
;;;; FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
;;;; DEALINGS IN THE SOFTWARE.

;;;; Original Author:
;;;;   Brian C. Williams (ITC and ITC with conditional variables).

;;;; Additions:
;;;;;  Patrick R. Conrad (dispatching and disjunctive problems).

(in-package :cl-user)


(defpackage :ITC (:use
				  #:cl
				  #:mtk-utils
				  #:mtk-utils-infinity
				  #:state-space
				  #:cs
				  #:temporal-constraints
				  #:metacopy
				  #:abstract-data-types)

		;	(:shadowing-import-from :cs "CONSISTENT?")
			(:shadow "QUEUE-EMPTY?")
			(:export

			 ;; From stn-defs.lisp and itc-stn-defs.lisp

			 ;; Interface variable
			 "*DEFAULT-STN*"

			 ;; STN Object
			 "ITC-STN"
			 "STN"
			 "START"					; The default name for the START event.
			 "STN-NAME"
			 "STN-START"
			 "STN-EVENTS"
			 "STN-CONSTRAINTS"
			 "STN-EVENT-HT"

			 ;; EVENT Object
			 "EVENT-NAME"
			 "EVENT-NETWORK"
			 "EVENT-LB"
			 "EVENT-UB"
			 "EVENT-LB-SUPPORT"
			 "EVENT-UB-SUPPORT"

			 ;; Simple Temporal Constraint Object
			 "ITC-STC"
			 "STC-SOURCE"
			 "STC-START"
			 "STC-END"
			 "STC-LB"
			 "STC-UB"
			 "STC-LB-RELAXABLE?"
			 "STC-LB-COST-RATIO"
			 "STC-LB-RELAXED?"
			 "STC-RELAXED-LB"
			 "STC-UB-RELAXABLE?"
			 "STC-UB-COST-RATIO"
			 "STC-UB-RELAXED?"
			 "STC-RELAXED-UB"

			 "APPLY-RELAXATION"
			 "UNDO-RELAXATION"

			 "STC-D-EDGES"
			 "STC-LB-CONSEQUENT"
			 "STC-UB-CONSEQUENT"
			 "STC?"
			 "STC-REMOVED?"
			 ""
;;;;;; 		 stc-propagated?
;;;;;;		 stc-in-conflict?
			 "PRINT-STC!"

			 ;; STC related functions
			 "SET-LB-SUPPORT-RELATION!"
			 "SET-UB-SUPPORT-RELATION!"
			 "CLEAR-LB-SUPPORT-RELATION!"
			 "CLEAR-UB-SUPPORT-RELATION!"

			 "DO-INSERTED-D-EDGES" ;; Macro
			 
			 "STC-GUARD-TO-STATE-ASSIGNMENT-W-TRUTH-DESCRIPTION"
			 
			 ;; From manipulate-stn.lisp
			 
;;;			 "NEW-STN"
;;;			 "NEW-STC"
;;;			 "INSERT-NEW-STC"
			 "NEW-CONSTRAINT"
			 "INSERT-NEW-CONSTRAINT"
			
;;;;;;			find-state-variable
;;;			 define-state-variable
			
;;;			 get-assignment
;;;			 constraint-system-assignment-description

;;;			 assign!
;;;			 unassign!
			
;;;			 assert!
;;;			 unassert!

;;;			 insert-constraint
			 "REMOVE-CONSTRAINT"

			 "GET-EVENT"
			 "FIND-EVENT"

			 "PRINT-STN!"
	
			 "CONSISTENT-STN?"
			 "EVENT-TIME"
			 "EVENT-SUPPORT"
;;;          event-consequences
			 ;; From manipulate-itc-stn			 
			 "EVENT-TIME-BOUNDS"
			 "EVENT-PAIR-TIME-BOUND"
			 
			 
			 
			 ;; From propagate-ub.lisp
			 "STN-INITIALIZE!"
			 
			 ;; from consistency.lisp
;;;			 "CONSISTENT?"
;;;			 consistent-with?
;;;			 inconsistent-with?
			 

			 ;;from dispatch-stn.lisp
			 "NEXT-TIME-WITH-EPISODES"
			 "STN-DISPATCH"
			 "DISPATCH-UNCOMPLETED-EPISODES"
			 "INCOMPLETE-EPISODES"
			 "DISPATCH-WAITING-FOR-EPISODE"
			 "A"
			 "WAITING-FOR-EPISODE"
			 
			 )
			)