(in-package :ITC)

(deftest (test10 :itc) ()

  (let ((stn (make-instance 'STN :name  'test10
							:start-name 'ea)))

	;;add some constraints
	(insert-new-constraint stn :source 'test1 :start 'ea :end 'eb :lb 1 :ub 6)
	(insert-new-constraint stn :source 'test1 :start 'eb :end 'ec :lb 1 :ub 7)
	(insert-new-constraint stn :source 'test1 :start 'ea :end 'ed :lb 2 :ub 3)
	(insert-new-constraint stn :source 'test1 :start 'ed :end 'eb :lb 2 :ub 3)

	;;run apsp and test the results
	(test t (apsp-floyd-warshall! stn))
	(test 10 (get-event-pair-ub  (get-event-pair (find-event 'ed stn) (find-event 'ec stn) stn)))
	(test -5 (get-event-pair-ub  (get-event-pair (find-event 'ec stn) (find-event 'ea stn) stn)))
	))

(deftest (test11 :itc) ()

  "Almost the same test as test10, but is inconsistent." 

  (let ((stn (make-instance 'STN :name  'test11
							:start-name 'ea)))

	;;add some constraints
	(insert-new-constraint stn :source 'test1 :start 'ea :end 'eb :lb 5 :ub 6)
	(insert-new-constraint stn :source 'test1 :start 'eb :end 'ec :lb 1 :ub 7)
	(insert-new-constraint stn :source 'test1 :start 'ea :end 'ed :lb 1 :ub 2)
	(insert-new-constraint stn :source 'test1 :start 'ed :end 'eb :lb 2 :ub 2)
	
	(test nil  (consistent-stn? stn))
	))

(deftest (test12 :itc) ()

  "Try out new b>=."

  (test t (b>= *infinity* 4))
  (test t (b>= *infinity* -4))
  (test t (b>= *infinity* *infinity*))
  (test nil (b>= *-infinity* *infinity*))
  (test t (b>= *infinity* *-infinity*))
  (test t (b>= *-infinity* *-infinity*))
  (test t (b>= 6 *-infinity*)))



(deftest (test13 :itc) ()

  "Test out the dispatcher."

  ;;Construct the stn.
  (let ((stn (make-instance 'STN :name  'test13
							:start-name 'ea)))

	;;add some constraints
	(insert-new-constraint stn :source 'test1 :start 'ea :end 'eb :lb 1 :ub 6)
	(insert-new-constraint stn :source 'test1 :start 'eb :end 'ec :lb 1 :ub 7)
	(insert-new-constraint stn :source 'test1 :start 'ea :end 'ed :lb 2 :ub 3)
	(insert-new-constraint stn :source 'test1 :start 'ed :end 'eb :lb 2 :ub 3)

;;	(format t "Result: ~A~%" (offline-dispatch-stn stn))
	(test '((EA (2 3) 0) (ED (4 5) 2) (EB (5 11) 4) (EC (:INFINITY :INFINITY) 5))
	 	  (offline-dispatch-stn stn) :test #'eq-dispatch?
	 	  :fail-info "Dispatched incorrectly.")

	))

(deftest (test14 :itc) ()

  "Test out the dispatcher."

;;Construct the stn.
  (let ((stn (make-instance 'STN :name  'test14
							:start-name 'ea)))

	;;add some constraints
	(insert-new-constraint stn :source 'test1 :start 'ea :end 'eb :lb 1 :ub 6)
	(insert-new-constraint stn :source 'test1 :start 'eb :end 'ec :lb 1 :ub 7)
	(insert-new-constraint stn :source 'test1 :start 'ea :end 'ed :lb 2 :ub 3)
	(insert-new-constraint stn :source 'test1 :start 'ed :end 'eb :lb 2 :ub 3)
	(insert-new-constraint stn :source 'test1 :start 'ea :end 'ee :lb 0 :ub *infinity* )
	(insert-new-constraint stn :source 'test1 :start 'ec :end 'ee :lb 0 :ub 1 )

	(test '((EA (2 3) 0) (ED (4 5) 2) (EB (5 11) 4) (EC (5 6) 5) (EE (:INFINITY :INFINITY) 5))
		  (offline-dispatch-stn stn) :test #'eq-dispatch?
		  :fail-info "Dispatched incorrectly.")

	))



(deftest (test15 :itc) ()

  ;; Test the modify-constraint function.
  
  (let ((stn (make-instance 'ITC-STN :name  'test40-1	:start-name 'START)))

	(let ((aa (insert-new-constraint stn :source 'test40-1
									 :start 'start :end 'e1 :lb 0 :ub 0))
		  (ab (insert-new-constraint stn :source 'test40-1
									 :start 'e1 :end 'e2 :lb 5 :ub 10))
		  (bc (insert-new-constraint stn :source 'test40-1
									 :start 'e2 :end 'e3 :lb 5 :ub 10))
		  (ac (insert-new-constraint stn :source 'test40-1
									 :start 'e1 :end 'e3 :lb 10 :ub 10)))
	 

	 ;; (test t (consistent-stn? stn :initialize? t))
	  (print-stn! stn)
	  (apsp-floyd-warshall! stn)
	  ;;(update-stn-constraints! stn)

	  (print-stn! stn)

	 ; (modify-constraint! cb 4 5 stn)

	 ; (test nil (consistent-stn? stn))

	 ; (modify-constraint! cb 1 1000 stn)

	 ; (test t (consistent-stn? stn))

	 ; (modify-constraint! cd 3 4 stn)
	  
	 ; (print-stn! stn)

	 ; (test nil (consistent-stn? stn))

	  ;; (modify-constraint! cb 10 11.11 stn)
	  ;; (test nil (consistent-stn? stn))


		)))

(deftest (test16 :itc) ()
  "Test out the apsp-floyd-warshall method."
  (let ((stn (make-instance 'STN :name  'test16
							:start-name 'ea)))

	;;add some constraints
	(insert-new-constraint stn :source 'test1 :start 'ea :end 'eb :lb 5 :ub 10)
	(insert-new-constraint stn :source 'test1 :start 'eb :end 'ec :lb 5 :ub 10)
	(insert-new-constraint stn :source 'test1 :start 'ea :end 'ec :lb 10 :ub 10)

	;;run apsp and test the results
	(print-stn! stn)
	(test t (consistent-stn? stn));;; note this performs APSP update too. Different from consistent-stn? in ITC
	(print-stn! stn)
	(test t (apsp-floyd-warshall! stn))

	)
  )




