;;;; Copyright (c) 2009 Massachusetts Institute of Technology

;;;; This software may not be redistributed, and can only be retained and used
;;;; with the explicit written consent of the author, subject to the following
;;;; conditions:

;;;; The above copyright notice and this permission notice shall be included in
;;;; all copies or substantial portions of the Software.

;;;; This software may only be used for non-commercial, non-profit, research
;;;; activities.

;;;; THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESSED
;;;; OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
;;;; FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
;;;; THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
;;;; LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
;;;; FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
;;;; DEALINGS IN THE SOFTWARE.

;;;; Authors:
;;;;   David C. Wang

(in-package :cl-user)

(asdf:defsystem #:kirk
  :name "Kirk"
  :version "0.1"
  :description "MERS Toolkit: Kirk"
  :author "David Wang"
  :maintainer "MIT MERS Group"
  :components ((:file "package")
			   (:file "trajectory-file"
					  :depends-on ("package"))
			   (:file "environment-file"
					  :depends-on ("package"))
			   (:file "explanations"
					  :depends-on ("package"))
			   (:file "kirk"
					  :depends-on ("package" "explanations"))
			   (:file "kirk-vz-graph"
					  :depends-on ("package" "trajectory-file" "environment-file" "explanations"))
			   (:file "kirk-test"
					  :depends-on ("package" "kirk" "kirk-vz-graph"))
			   (:file "compute-span"
					  :depends-on ("package"))
			   (:file "test-compute-span"
					  :depends-on ("package" "compute-span"))
			   ;; (:file "compute-hierarchy"
			   ;; 		  :depends-on ("package"))
			   (:module "resource-manager"
			   			:components ((:file "submission")
									 (:file "kirkrm-state"
											:depends-on ("submission"))
									 (:file "resource-manager-impl"
											:depends-on ("kirkrm-state"))
			   						 (:file "resource-manager-test"
											:depends-on ("resource-manager-impl")))
			   			:depends-on ("package" "compute-span" "kirk-vz-graph" "environment-file"))
			   )
  
  :depends-on (#:mtk-utils #:mtk-utils-infinity #:mtk-utils-2d-geometry #:abstract-data-types 
			   #:s-xml #:parse-number #:mtk-graph #:mtk-graph-algorithms #:tpn #:itc 
			   #:cl-ppcre #:visibility-graph 
			   ;; for resource-manager-impl.lisp
			   #:resource-manager-interface #:drake2 #:simplex #:parse-number
			   #:mtk-utils-threading 
			   #:bordeaux-threads
			   ;; to support uncontrollable choices
			   #:stochastic))


