;;;; Copyright (c) 2009 Massachusetts Institute of Technology

;;;; This software may not be redistributed, and can only be retained and used
;;;; with the explicit written consent of the author, subject to the following
;;;; conditions:

;;;; The above copyright notice and this permission notice shall be included in
;;;; all copies or substantial portions of the Software.

;;;; This software may only be used for non-commercial, non-profit, research
;;;; activities.

;;;; THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESSED
;;;; OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
;;;; FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
;;;; THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
;;;; LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
;;;; FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
;;;; DEALINGS IN THE SOFTWARE.

;;;; Authors:
;;;;   David C. Wang
;;;;   Alborz Geramifard

(in-package #:cl-user)

(defpackage #:kirk
  (:use #:cl #:cl-user #:asdf 
		#:mtk-utils-2d-geometry #:mtk-utils-infinity #:abstract-data-types 
		#:s-xml #:parse-number #:mtk-graph #:mtk-graph-algorithms 
		#:tpn #:visibility-graph #:resource-manager #:stochastic)
  (:shadow #:copy-tpn)
  (:export 

   ;; from vz-interface.lisp
   "KIRK-VZ-GRAPH-FILE"
   "KIRK-VZ-GRAPH"
   "KIRK-VZ-GRAPH-STREAM"

   ;; from interface.lisp
   "KIRK-FILE"
   "KIRK"
   "KIRK-STREAM"

   ;; from environment-file.lisp
   "WRITE-ENVIRONMENT-FILE"
   "WRITE-ENVIRONMENT-STREAM"
   "READ-ENVIRONMENT-FILE"
   "READ-ENVIRONMENT-STREAM"
   "ENVIRONMENT"
   "ENV-VEHICLES"
   "ENV-FEATURES"
   "ENV-OBSTACLES"
   "ENV-VEHICLE"
   "ENV-VEHICLE-NAME"
   "ENV-VEHICLE-ACTIONS"
   "ENV-VEHICLE-ACTION"
   "ENV-VEHICLE-ACTION-NAME"
   "ENV-VEHICLE-ACTION-MINV"
   "ENV-VEHICLE-ACTION-MAXV"
   "ENV-VEHICLE-ACTION-MINA"
   "ENV-VEHICLE-ACTION-MAXA"
   "ENV-OBSTACLE"
   "ENV-OBSTACLE-NAME"
   "ENV-OBSTACLE-TYPE"
   "ENV-OBSTACLE-POLYGON"
   "MAKE-OBSTACLE-FROM-LXML"
   ;; TODO: fill in other make methods
   "ENV-FEATURE"
   "ENV-FEATURE-NAME"
   "ENV-FEATURE-CENTER"
   "ENV-FEATURE-RADIUS"

   ;; from compute-span.lisp
   #:compute-span

   ;; from resource-manager/resource-manager-impl.lisp
   #:getFeasibility
   #:submit
   #:cancel
   #:start
   #:stop
   #:addObstacle
   #:removeObstacle
   #:replan
   #:getTPNandENV 
   #:dispatcher-running?
   #:kirkrm-running?
   #:notify-activity-completed
   
   )
)

