;;; TEST SCRIPT

(in-package #:kirk)

(defparameter *rm-test-tpn-xml* 
"<TPNS>
  <TPN>
    <FORMAT>Spec2</FORMAT>
    <START>START</START>
    <END>NODE2</END>
    <ARC>
      <START>START</START>
      <END>NODE1</END>
      <COST>0.0</COST>
      <LOWERBOUND>5.0</LOWERBOUND>
      <UPPERBOUND>6.0</UPPERBOUND>
    </ARC>
    <ARC>
      <START>NODE1</START>
      <END>NODE2</END>
      <PRIMITIVE>UAV.flyTo(\"92f1260c-8ce4-4f71-85c2-f71ab1cc1caa\", \"2b990672-21df-4af3-b707-b2b247f4c593\", dog)</PRIMITIVE>
      <COST>0.0</COST>
      <LOWERBOUND>0.0</LOWERBOUND>
      <UPPERBOUND>+INF</UPPERBOUND>
    </ARC>
  </TPN>
</TPNS>"
)

(defparameter *rm-test-env-xml-start*
"<ENVIRONMENT>
 <VEHICLE>
    <NAME>UAV</NAME>
    <INITIAL_POSITION>
      <X2D>0.0</X2D>
      <Y2D>0.0</Y2D>
      <Z2D>10000.0</Z2D>
    </INITIAL_POSITION>
    <INITIAL_VELOCITY>
      <DIRECTION>
        <X2D>-0.004249852685447234</X2D>
        <Y2D>-0.007159751818306398</Y2D>
        <Z2D>0.9999653377522904</Z2D>
      </DIRECTION>
      <SPEED>0.1</SPEED>
    </INITIAL_VELOCITY>
    <ACTION>
      <NAME>flyTo</NAME>
      <MIN_ACCELERATION>1.0</MIN_ACCELERATION>
      <MAX_ACCELERATION>99.0</MAX_ACCELERATION>
      <MIN_VELOCITY>2.0</MIN_VELOCITY>
      <MAX_VELOCITY>88.0</MAX_VELOCITY>
    </ACTION>
 </VEHICLE>
</ENVIRONMENT>"
)

(defparameter *rm-test-env-xml* 
"<ENVIRONMENT>
  <FEATURE>
    <NAME>2b990672-21df-4af3-b707-b2b247f4c593</NAME>
    <TARGET>UAV</TARGET>
    <CENTER>
      <X2D>2.0</X2D>
      <Y2D>3.0</Y2D>
      <Z2D>10000.0</Z2D>
    </CENTER>
    <RADIUS>100.0</RADIUS>
  </FEATURE>
  <FEATURE>
    <NAME>92f1260c-8ce4-4f71-85c2-f71ab1cc1caa</NAME>
    <TARGET>UAV</TARGET>
    <CENTER>
      <X2D>0.0</X2D>
      <Y2D>0.0</Y2D>
      <Z2D>10000.0</Z2D>
    </CENTER>
    <RADIUS>100.0</RADIUS>
  </FEATURE>
</ENVIRONMENT>"
)

(defvar *rm-test-tpn* (first (tpn:parse-tpn-string *rm-test-tpn-xml* 'tpn::get-event 'tpn::make-episode 'tpn::add-episode 'tpn::make-tpn)))

(defvar *rm-test-env* (with-input-from-string (env-stream *rm-test-env-xml*)
						(read-environment-stream env-stream)))

(defun read-mars-file-to-mbstring (mars-filename)
	(mtk-utils:read-file-to-string (cl-user::mars-pathname mars-filename) :multibyte t))

(defun test-resource-manager-start ()
  (start (make-instance 'test-resource-manager) *rm-test-env-xml-start*))

(defun test-resource-manager-getfeasibility ()
  (start (make-instance 'test-resource-manager) *rm-test-env-xml-start*)
  (format t "~a~%" (getFeasibility (make-instance 'test-resource-manager) "id" *rm-test-tpn-xml* *rm-test-env-xml*))
  (stop (make-instance 'test-resource-manager)))

(defun test-resource-manager-submit ()
  (start (make-instance 'test-resource-manager) *rm-test-env-xml-start*)
  (submit (make-instance 'test-resource-manager) "id" *rm-test-tpn-xml* *rm-test-env-xml*)
  ;;(stop (make-instance 'test-resource-manager))
  )

(defun test-resource-manager-1 ()
  (let ((start-env-xml (read-mars-file-to-mbstring "Kirk/resource-manager/tests/test1/startenv.xml"))
		(tpn-xml (read-mars-file-to-mbstring "Kirk/resource-manager/tests/test1/tpn.xml"))
		(env-xml (read-mars-file-to-mbstring "Kirk/resource-manager/tests/test1/env.xml")))
	;(format t "~s~%~s~%~s~%" start-env-xml tpn-xml env-xml)
	(start (make-instance 'test-resource-manager) start-env-xml)
	;(getFeasibility (make-instance 'test-resource-manager) "id" tpn-xml env-xml)  
	(submit (make-instance 'test-resource-manager) "id" tpn-xml env-xml)
	))

(defun test-resource-manager-2 ()
  (let ((start-env-xml (read-mars-file-to-mbstring "Kirk/resource-manager/tests/test2/startenv.xml"))
		(tpn-xml (read-mars-file-to-mbstring "Kirk/resource-manager/tests/test2/tpn.xml"))
		(env-xml (read-mars-file-to-mbstring "Kirk/resource-manager/tests/test2/env.xml")))
	;(format t "~s~%~s~%~s~%" start-env-xml tpn-xml env-xml)
	(start (make-instance 'test-resource-manager) start-env-xml)
	;(getFeasibility (make-instance 'test-resource-manager) "id" tpn-xml env-xml)
	(submit (make-instance 'test-resource-manager) "id" tpn-xml env-xml)
	))

(defun test-resource-manager-3 ()
  (let ((start-env-xml (read-mars-file-to-mbstring "Kirk/resource-manager/tests/test3/startenv.xml"))
		(tpn-xml (read-mars-file-to-mbstring "Kirk/resource-manager/tests/test3/tpn.xml"))
		(env-xml (read-mars-file-to-mbstring "Kirk/resource-manager/tests/test3/env.xml")))
	;(format t "~s~%~s~%~s~%" start-env-xml tpn-xml env-xml)
	(start (make-instance 'test-resource-manager) start-env-xml)
	;(getFeasibility (make-instance 'test-resource-manager) "id" tpn-xml env-xml)
	(submit (make-instance 'test-resource-manager) "id" tpn-xml env-xml)
	))

(defun test-resource-manager-4 ()
  (let ((start-env-xml (read-mars-file-to-mbstring "Kirk/resource-manager/tests/test4/startenv.xml"))
		(tpn-xml (read-mars-file-to-mbstring "Kirk/resource-manager/tests/test4/tpn.xml"))
		(env-xml (read-mars-file-to-mbstring "Kirk/resource-manager/tests/test4/env.xml")))
	;(format t "~s~%~s~%~s~%" start-env-xml tpn-xml env-xml)
	(start (make-instance 'test-resource-manager) start-env-xml)
	(getFeasibility (make-instance 'test-resource-manager) "id" tpn-xml env-xml)
	(stop (make-instance 'test-resource-manager))
	))

(defun test-resource-manager-6 ()
  (let ((start-env-xml (read-mars-file-to-mbstring "Kirk/resource-manager/tests/test6/startenv.xml"))
		(tpn1-xml (read-mars-file-to-mbstring "Kirk/resource-manager/tests/test6/tpn1.xml"))
		(env1-xml (read-mars-file-to-mbstring "Kirk/resource-manager/tests/test6/env1.xml"))
		(tpn2-xml (read-mars-file-to-mbstring "Kirk/resource-manager/tests/test6/tpn2.xml"))
		(env2-xml (read-mars-file-to-mbstring "Kirk/resource-manager/tests/test6/env2.xml")))
	(start (make-instance 'test-resource-manager) start-env-xml)
	(submit (make-instance 'test-resource-manager) "id1" tpn1-xml env1-xml)
	(sleep 4)
	(submit (make-instance 'test-resource-manager) "id2" tpn2-xml env2-xml)
	(sleep 20)
	(stop (make-instance 'test-resource-manager))
	))

(defun test-resource-manager-7 ()
  "Problem: The lookAt primitive isn't requested until 2 minutes after the initial flyTo primitive is completed."
  (let ((start-env-xml (read-mars-file-to-mbstring "Kirk/resource-manager/tests/test7/startenv.xml"))
		(tpn-xml (read-mars-file-to-mbstring "Kirk/resource-manager/tests/test7/tpn.xml"))
		(env-xml (read-mars-file-to-mbstring "Kirk/resource-manager/tests/test7/env.xml")))
	;(format t "~s~%~s~%~s~%" start-env-xml tpn-xml env-xml)
	(start (make-instance 'test-resource-manager) start-env-xml)
	(submit (make-instance 'test-resource-manager) "id" tpn-xml env-xml)
	(sleep (* 2 60))
	(stop (make-instance 'test-resource-manager))
	))

(defun test-resource-manager-8 ()
  "Problem: The lookAt primitive isn't requested until 2 minutes after the initial flyTo primitive is completed."
  (let ((start-env-xml (read-mars-file-to-mbstring "Kirk/resource-manager/tests/test8/startenv.xml"))
		(tpn1-xml (read-mars-file-to-mbstring "Kirk/resource-manager/tests/test8/tpn1.xml"))
		(env1-xml (read-mars-file-to-mbstring "Kirk/resource-manager/tests/test8/env1.xml"))
		(tpn2-xml (read-mars-file-to-mbstring "Kirk/resource-manager/tests/test8/tpn2.xml"))
		(env2-xml (read-mars-file-to-mbstring "Kirk/resource-manager/tests/test8/env2.xml"))
		(tpn3-xml (read-mars-file-to-mbstring "Kirk/resource-manager/tests/test8/tpn3.xml"))
		(env3-xml (read-mars-file-to-mbstring "Kirk/resource-manager/tests/test8/env3.xml")) )
	;(format t "~s~%~s~%~s~%" start-env-xml tpn-xml env-xml)
	(start (make-instance 'test-resource-manager) start-env-xml)
	(submit (make-instance 'test-resource-manager) "id1" tpn1-xml env1-xml)
	(sleep (* 5 60))
	(submit (make-instance 'test-resource-manager) "id2" tpn2-xml env2-xml)
	(sleep (* 1 60))
	(submit (make-instance 'test-resource-manager) "id3" tpn3-xml env3-xml)
	(sleep (* 5 60))
	(stop (make-instance 'test-resource-manager))
	))

(defun test-resource-manager-9 ()
  "Problem: The lookAt primitive isn't requested until 2 minutes after the initial flyTo primitive is completed."
  (let ((start-env-xml (read-mars-file-to-mbstring "Kirk/resource-manager/tests/test9/startenv.xml"))
		(tpn1-xml (read-mars-file-to-mbstring "Kirk/resource-manager/tests/test9/tpn1.xml"))
		(env1-xml (read-mars-file-to-mbstring "Kirk/resource-manager/tests/test9/env1.xml"))
		(tpn2-xml (read-mars-file-to-mbstring "Kirk/resource-manager/tests/test9/tpn2.xml"))
		(env2-xml (read-mars-file-to-mbstring "Kirk/resource-manager/tests/test9/env2.xml")) )
	;(format t "~s~%~s~%~s~%" start-env-xml tpn-xml env-xml)
	(start (make-instance 'test-resource-manager) start-env-xml)
	(submit (make-instance 'test-resource-manager) "id1" tpn1-xml env1-xml)
	(sleep 2)
	(submit (make-instance 'test-resource-manager) "id2" tpn2-xml env2-xml)
	(sleep 60)
	(stop (make-instance 'test-resource-manager))
	))

(defun test-resource-manager-10 ()
  "Problem: The lookAt primitive isn't requested until 2 minutes after the initial flyTo primitive is completed."
  (let ((start-env-xml (read-mars-file-to-mbstring "Kirk/resource-manager/tests/test10/startenv.xml"))
		(tpn1-xml (read-mars-file-to-mbstring "Kirk/resource-manager/tests/test10/tpn1.xml"))
		(env1-xml (read-mars-file-to-mbstring "Kirk/resource-manager/tests/test10/env1.xml"))
		(tpn2-xml (read-mars-file-to-mbstring "Kirk/resource-manager/tests/test10/tpn2.xml"))
		(env2-xml (read-mars-file-to-mbstring "Kirk/resource-manager/tests/test10/env2.xml")) )
	;(format t "~s~%~s~%~s~%" start-env-xml tpn-xml env-xml)
	(start (make-instance 'test-resource-manager) start-env-xml)
	(submit (make-instance 'test-resource-manager) "id1" tpn1-xml env1-xml)
	(sleep 1)
	(submit (make-instance 'test-resource-manager) "id2" tpn2-xml env2-xml)
	(sleep 3)
	(stop (make-instance 'test-resource-manager))
	))

(defun test-resource-manager-11 ()
  ""
  (let ((start-env-xml (read-mars-file-to-mbstring "Kirk/resource-manager/tests/test11/startenv.xml"))
		(tpn1-xml (read-mars-file-to-mbstring "Kirk/resource-manager/tests/test11/tpn1.xml"))
		(env1-xml (read-mars-file-to-mbstring "Kirk/resource-manager/tests/test11/env1.xml"))
		(tpn2-xml (read-mars-file-to-mbstring "Kirk/resource-manager/tests/test11/tpn2.xml"))
		(env2-xml (read-mars-file-to-mbstring "Kirk/resource-manager/tests/test11/env2.xml")) )
	;(format t "~s~%~s~%~s~%" start-env-xml tpn-xml env-xml)
	(start (make-instance 'test-resource-manager) start-env-xml)
	(submit (make-instance 'test-resource-manager) "id1" tpn1-xml env1-xml)
	(sleep (* 5 60))
	(submit (make-instance 'test-resource-manager) "id2" tpn2-xml env2-xml)
	(sleep 30)
	(stop (make-instance 'test-resource-manager))
	))

(defun test-resource-manager-12 ()
  ""
  (let ((start-env-xml (read-mars-file-to-mbstring "Kirk/resource-manager/tests/test12/startenv.xml"))
		(tpn1-xml (read-mars-file-to-mbstring "Kirk/resource-manager/tests/test12/tpn1.xml"))
		(env1-xml (read-mars-file-to-mbstring "Kirk/resource-manager/tests/test12/env1.xml"))
		(tpn2-xml (read-mars-file-to-mbstring "Kirk/resource-manager/tests/test12/tpn2.xml"))
		(env2-xml (read-mars-file-to-mbstring "Kirk/resource-manager/tests/test12/env2.xml"))
		(tpn3-xml (read-mars-file-to-mbstring "Kirk/resource-manager/tests/test12/tpn3.xml"))
		(env3-xml (read-mars-file-to-mbstring "Kirk/resource-manager/tests/test12/env3.xml"))
		)
	;(format t "~s~%~s~%~s~%" start-env-xml tpn-xml env-xml)
	(start (make-instance 'test-resource-manager) start-env-xml)
	(submit (make-instance 'test-resource-manager) "id1" tpn1-xml env1-xml)
	(sleep (* 2 60))
	(submit (make-instance 'test-resource-manager) "id2" tpn2-xml env2-xml)
	(sleep 30)
	(submit (make-instance 'test-resource-manager) "id3" tpn3-xml env3-xml)
	(sleep 30)
	(stop (make-instance 'test-resource-manager))
	))

(defun test-resource-manager-13 ()
  ""
  (let ((start-env-xml (read-mars-file-to-mbstring "Kirk/resource-manager/tests/test13/startenv.xml"))
		(obs-xml (read-mars-file-to-mbstring "Kirk/resource-manager/tests/test13/addobstacle.xml"))
		(tpn-xml (read-mars-file-to-mbstring "Kirk/resource-manager/tests/test13/tpn.xml"))
		(env-xml (read-mars-file-to-mbstring "Kirk/resource-manager/tests/test13/env.xml"))
		(rm (make-instance 'test-resource-manager))
		)
	(start rm start-env-xml)
	(addObstacle rm obs-xml)
	(replan rm)
	(submit rm "id1" tpn-xml env-xml)
	(sleep 120)
	(stop rm)
	))

(defun test-resource-manager-14 ()
  ""
  (let ((start-env-xml (read-mars-file-to-mbstring "Kirk/resource-manager/tests/test14/startenv.xml"))
		(tpn1-xml (read-mars-file-to-mbstring "Kirk/resource-manager/tests/test14/tpn1.xml"))
		(tpn1-pdf     (cl-user::mars-pathname "Kirk/resource-manager/tests/test14/tpn1.pdf"))
		(env1-xml (read-mars-file-to-mbstring "Kirk/resource-manager/tests/test14/env1.xml"))
		(tpn2-xml (read-mars-file-to-mbstring "Kirk/resource-manager/tests/test14/tpn2.xml"))
		(tpn2-pdf     (cl-user::mars-pathname "Kirk/resource-manager/tests/test14/tpn2.pdf"))
		(env2-xml (read-mars-file-to-mbstring "Kirk/resource-manager/tests/test14/env2.xml"))
		)
	;; print out the intermediate tpns provided by Lincoln
	(let ((inttpn-submit1-xml (read-mars-file-to-mbstring "Kirk/resource-manager/tests/test14/inttpn_submit1.xml"))
		  (inttpn-submit1-pdf     (cl-user::mars-pathname "Kirk/resource-manager/tests/test14/inttpn_submit1.pdf"))
		  (inttpn-submit2-xml (read-mars-file-to-mbstring "Kirk/resource-manager/tests/test14/inttpn_submit2.xml"))
		  (inttpn-submit2-pdf     (cl-user::mars-pathname "Kirk/resource-manager/tests/test14/inttpn_submit2.pdf"))
		  (inttpn-cancel-xml  (read-mars-file-to-mbstring "Kirk/resource-manager/tests/test14/inttpn_cancel.xml"))
		  (inttpn-cancel-pdf      (cl-user::mars-pathname "Kirk/resource-manager/tests/test14/inttpn_cancel.pdf"))
		  )
	  (tpn2dot inttpn-submit1-xml inttpn-submit1-pdf :verbose t)
	  (tpn2dot inttpn-submit2-xml inttpn-submit2-pdf :verbose t)
	  (tpn2dot inttpn-cancel-xml inttpn-cancel-pdf :verbose t) 
	  (tpn2dot tpn1-xml tpn1-pdf :verbose t) 
	  (tpn2dot tpn2-xml tpn2-pdf :verbose t) )
	;(format t "~s~%~s~%~s~%" start-env-xml tpn-xml env-xml)
	(start (make-instance 'test-resource-manager) start-env-xml)
	(submit (make-instance 'test-resource-manager) "id1" tpn1-xml env1-xml)
	(sleep 8)
	(submit (make-instance 'test-resource-manager) "id2" tpn2-xml env2-xml)
	(sleep 1.5)
	(cancel (make-instance 'test-resource-manager) "id1" "")
	(sleep 80)
	(stop (make-instance 'test-resource-manager))
	))

(defun test-resource-manager-15 ()
  ""
  (let ((start-env-xml (read-mars-file-to-mbstring "Kirk/resource-manager/tests/test15/startenv.xml"))
		(tpn-xml (read-mars-file-to-mbstring "Kirk/resource-manager/tests/test15/tpn.xml"))
		(env-xml (read-mars-file-to-mbstring "Kirk/resource-manager/tests/test15/env.xml"))
		(rm (make-instance 'test-resource-manager))
		)
	(start rm start-env-xml)
	(sleep 19)
	(submit rm "id1" tpn-xml env-xml)
	(sleep 6)
	(cancel rm "id1" "")
	(submit rm "id2" tpn-xml env-xml)
	(sleep 80)
	(stop rm)
	))

(defun test-resource-manager-16 ()
  ""
  (let ((start-env-xml (read-mars-file-to-mbstring "Kirk/resource-manager/tests/test16/startenv.xml"))
		(tpn-xml (read-mars-file-to-mbstring "Kirk/resource-manager/tests/test16/tpn.xml"))
		(env-xml (read-mars-file-to-mbstring "Kirk/resource-manager/tests/test16/env.xml"))
		(rm (make-instance 'test-resource-manager))
		)
	(start rm start-env-xml)
	(submit rm "id1" tpn-xml env-xml)
	(sleep 2)
	(cancel rm "id1" "")
	(sleep 80)
	(stop rm)
	))

(defun test-resource-manager-17 ()
  ""
  (let ((start-env-xml (read-mars-file-to-mbstring "Kirk/resource-manager/tests/test17/startenv.xml"))
		(tpn1-xml (read-mars-file-to-mbstring "Kirk/resource-manager/tests/test17/tpn1.xml"))
		(env1-xml (read-mars-file-to-mbstring "Kirk/resource-manager/tests/test17/env1.xml"))
		(tpn2-xml (read-mars-file-to-mbstring "Kirk/resource-manager/tests/test17/tpn2.xml"))
		(env2-xml (read-mars-file-to-mbstring "Kirk/resource-manager/tests/test17/env2.xml"))
		(tpn1int-xml (read-mars-file-to-mbstring "Kirk/resource-manager/tests/test17/tpn1int.xml"))
		(tpn2int-xml (read-mars-file-to-mbstring "Kirk/resource-manager/tests/test17/tpn2int.xml"))
		(tpncomp1-xml (read-mars-file-to-mbstring "Kirk/resource-manager/tests/test17/tpncomp1.xml"))
		(tpncomp2-xml (read-mars-file-to-mbstring "Kirk/resource-manager/tests/test17/tpncomp2.xml"))
		(tpn1-pdf (cl-user::mars-pathname "Kirk/resource-manager/tests/test17/tpn1.pdf"))
		(tpn2-pdf (cl-user::mars-pathname "Kirk/resource-manager/tests/test17/tpn2.pdf"))
		(tpn1int-pdf (cl-user::mars-pathname "Kirk/resource-manager/tests/test17/tpn1int.pdf"))
		(tpn2int-pdf (cl-user::mars-pathname "Kirk/resource-manager/tests/test17/tpn2int.pdf"))
		(tpncomp1-pdf (cl-user::mars-pathname "Kirk/resource-manager/tests/test17/tpncomp1.pdf"))
		(tpncomp2-pdf (cl-user::mars-pathname "Kirk/resource-manager/tests/test17/tpncomp2.pdf"))
		(rm (make-instance 'test-resource-manager))
		)
	(declare (ignore start-env-xml env1-xml env2-xml rm))
	(tpn2dot tpn1-xml tpn1-pdf)
	(tpn2dot tpn2-xml tpn2-pdf)
	(tpn2dot tpn1int-xml tpn1int-pdf)
	(tpn2dot tpn2int-xml tpn2int-pdf)
	(tpn2dot tpncomp1-xml tpncomp1-pdf)
	(tpn2dot tpncomp2-xml tpncomp2-pdf)
	))

(defun test-resource-manager-18 ()
  ""
  (let ((start-env-xml (read-mars-file-to-mbstring "Kirk/resource-manager/tests/test18/startenv.xml"))
		(tpn1-xml (read-mars-file-to-mbstring "Kirk/resource-manager/tests/test18/tpn1.xml"))
		(env1-xml (read-mars-file-to-mbstring "Kirk/resource-manager/tests/test18/env1.xml"))
		(tpn2-xml (read-mars-file-to-mbstring "Kirk/resource-manager/tests/test18/tpn2.xml"))
		(env2-xml (read-mars-file-to-mbstring "Kirk/resource-manager/tests/test18/env2.xml"))
		(tpn3-xml (read-mars-file-to-mbstring "Kirk/resource-manager/tests/test18/tpn3.xml"))
		(env3-xml (read-mars-file-to-mbstring "Kirk/resource-manager/tests/test18/env3.xml"))
		(tpn1int-xml (read-mars-file-to-mbstring "Kirk/resource-manager/tests/test18/tpn1int.xml"))
		(tpn2int-xml (read-mars-file-to-mbstring "Kirk/resource-manager/tests/test18/tpn2int.xml"))
		(tpn3int-xml (read-mars-file-to-mbstring "Kirk/resource-manager/tests/test18/tpn3int.xml"))
		(tpn1-pdf (cl-user::mars-pathname "Kirk/resource-manager/tests/test18/tpn1.pdf"))
		(tpn2-pdf (cl-user::mars-pathname "Kirk/resource-manager/tests/test18/tpn2.pdf"))
		(tpn3-pdf (cl-user::mars-pathname "Kirk/resource-manager/tests/test18/tpn3.pdf"))
		(tpn1int-pdf (cl-user::mars-pathname "Kirk/resource-manager/tests/test18/tpn1int.pdf"))
		(tpn2int-pdf (cl-user::mars-pathname "Kirk/resource-manager/tests/test18/tpn2int.pdf"))
		(tpn3int-pdf (cl-user::mars-pathname "Kirk/resource-manager/tests/test18/tpn3int.pdf"))
		(rm (make-instance 'test-resource-manager))
		)
	;; (declare (ignore start-env-xml env1-xml env2-xml env3-xml rm))
	;; (tpn2dot tpn1-xml tpn1-pdf)
	;; (tpn2dot tpn2-xml tpn2-pdf)	
	;; (tpn2dot tpn3-xml tpn3-pdf)
	;; (tpn2dot tpn1int-xml tpn1int-pdf)
	;; (tpn2dot tpn2int-xml tpn2int-pdf)
	;; (tpn2dot tpn3int-xml tpn3int-pdf)

	(declare (ignore tpn1-pdf tpn2-pdf tpn3-pdf tpn1int-pdf tpn2int-pdf tpn3int-pdf tpn1int-xml tpn2int-xml tpn3int-xml))
	(start rm start-env-xml)
	(submit rm "id1" tpn1-xml env1-xml)
	(sleep 2)
	(submit rm "id2" tpn2-xml env2-xml)
	(submit rm "id3" tpn3-xml env3-xml)
	(sleep (* 5 60))
	(stop rm)
	))

(defun test-tpn-to-ldg-1 ()
  (let* ((tpn-xml (read-mars-file-to-mbstring "Kirk/resource-manager/tests/test5/tpn4.xml"))
		 (tpn-obj (first (tpn::parse-tpn-string tpn-xml 'tpn::get-event 'tpn::make-episode 'tpn::add-episode 'tpn::make-tpn)))  )	
	(multiple-value-bind (graph activities) (drake2:tpn-to-ldg tpn-obj)
	  (let* ((dispatchable-graph (drake2:construct-dispatchable-graph graph))
			 (dispatch (make-instance 'drake2:online-ldg-dispatch :start (intern "master-start" :keyword)
									  :ldg dispatchable-graph
									  :time-tol 0.1
									  :activities (drake2:activities-list activities))))

		(format t "result: ~a~%" dispatchable-graph)

		;; To run the dispatcher in THIS thread, use the following lines:
		(flet ((test-callback (id primitive lb ub)
				 (format t "Dispatching primitive ~s: ~s [~s,~s]~%" id primitive lb ub)
				 (flet ((done () 
						  (sleep lb)
						  (format t "Sending completed message for primitive: ~s~%" primitive)
						  (drake2:notify-complete dispatch id)))
				   (bordeaux-threads:make-thread #'done))
				 ))
		  (drake2:online-execute! dispatch :activity-callback #'test-callback)
		  
		  (format t "trace: ~a~%" (drake2::dispatch-trace dispatch))
										;	(format t "result: ~a~%" (drake2::dispatch-ldg dispatch))
		  ))
	  )))

(defun make-test-submission (id loc1 loc2 lb ub)
  (let* ((tpn (tpn::make-tpn (format nil "SUBMISSION~a" id) "START" "ENDNODE" '()))
		 (start (tpn::get-event "START" tpn))
		 (realstart (tpn::get-event "REALSTART" tpn))
		 (postfly (tpn::get-event "POSTFLY" tpn))
		 (sensorsetup (tpn::get-event "SENSORSETUP" tpn))
		 (setmode (tpn::get-event "SETMODE" tpn))
		 (lookat (tpn::get-event "LOOKAT" tpn))
		 (cameraready (tpn::get-event "CAMERAREADY" tpn))
		 (circle (tpn::get-event "CIRCLE" tpn))
		 (endnode (tpn::get-event "ENDNODE" tpn))  )
	;; create a function that will make it easier to add episodes for this tpn
	(flet ((make-add-episode (start end lb ub primitive)
			 (let ((description (list :episode))) ; Note: Use LIST, do NOT use the quote (')
			   (when primitive
				 (nconc description (list (tpn::make-association :primitive primitive))))
			   ;;(format t "~a~%" description)
			   (tpn::add-episode start end (tpn::make-episode start end lb ub 0 description tpn :support :CONTROL-PROGRAM )))))
	  ;; add the episodes
	  (make-add-episode start endnode       0 588 nil)
	  (make-add-episode start realstart     0 0 nil)
	  (make-add-episode realstart postfly   lb *infinity* (format nil "UAV0.flyTo(\"~a\",\"~a\")" loc1 loc2))
	  (make-add-episode postfly circle      0 *infinity* nil)
	  (make-add-episode circle endnode      0 1 nil)
	  (make-add-episode realstart sensorsetup lb ub nil)
	  (make-add-episode sensorsetup setmode 0 1 "UAV0.setMode()")
	  (make-add-episode setmode cameraready 0 *infinity* nil)
	  (make-add-episode sensorsetup lookat  0 1 "UAV0.lookAt()")
	  (make-add-episode lookat cameraready  0 *infinity* nil)
	  (make-add-episode cameraready circle  0 *infinity* nil)   )
	;; (tpn2dot tpn (cl-user::mars-pathname (format nil "Kirk/resource-manager/tests/long-running/submission~a.pdf" id)) )
	;; output to string
	(with-output-to-string (tpn-stream)
	  (tpn::write-tpn tpn-stream tpn :force-labeling? t)) ))

(defun test-resource-manager-long-running ()
  (let ((start-env-xml (read-mars-file-to-mbstring "Kirk/resource-manager/tests/long-running/startenv.xml"))
		(env-xml (read-mars-file-to-mbstring "Kirk/resource-manager/tests/long-running/env.xml")) )
	(start (make-instance 'test-resource-manager) start-env-xml)

	(loop for i from 0 to 9 do
		 (let ((id1 (* 2 i))
			   (id2 (+ 1 (* 2 i))))
		   (submit (make-instance 'test-resource-manager) (format nil "~a" id1) (make-test-submission id1 "loc2" "loc3" 3 20) env-xml)
		   (sleep (random 10))
		   (submit (make-instance 'test-resource-manager) (format nil "~a" id2) (make-test-submission id2 "loc3" "loc2" 3 20) env-xml)
		   (sleep (random 10))))

	(stop (make-instance 'test-resource-manager))
	) )


(defun test-resource-manager-long-running-print ()
  (let* ((tpn-path (cl-user::mars-pathname "Kirk/resource-manager/tests/long-running/temp/trace3int.xml"))
		 (dot-path (cl-user::mars-pathname "Kirk/resource-manager/tests/long-running/temp/trace3int.pdf"))
		 (tpn-xml (mtk-utils:read-file-to-string tpn-path :multibyte t))
		 (tpns (parse-tpn-string tpn-xml 'tpn::get-event 'tpn::make-episode 'tpn::add-episode 'tpn::make-tpn))
		 (tpn (first tpns)))
	;;(rationalize-tpn tpn)
	(tpn2dot tpn dot-path)
	))