(in-package #:kirk)

(defun test-compute-span ()
  (let* ((tpn (tpn::make-tpn "TEST-TPN" "EVENT0" "EVENT4" '()))
		 (event0 (tpn::get-event "EVENT0" tpn))
		 (event1 (tpn::get-event "EVENT1" tpn))
		 (event2 (tpn::get-event "EVENT2" tpn))
		 (event3 (tpn::get-event "EVENT3" tpn))
		 (event4 (tpn::get-event "EVENT4" tpn)))
	(declare (ignore event1 event2 event3))
	(flet ((make-add-episode (start end lb ub)
			 (tpn::add-episode start end (tpn::make-episode start end lb ub 0 '() tpn :support :CONTROL-PROGRAM ))))
	  ;; add the episodes
	  (make-add-episode event0 event4 2 5)
	  ;; compute the span
	  (compute-span tpn)
	  )))

(defun test-compute-span2 () 
  (let* ((tpn-xml "<TPN>
  <FORMAT>SPEC2</FORMAT>
  <NAME>master</NAME>
  <START>master_start</START>
  <END>master_end</END>
  <DECISION>noopid</DECISION>
  <ARC>
    <START>event23</START>
    <END>event21</END>
    <LOWERBOUND>5.0</LOWERBOUND>
    <UPPERBOUND>6.0</UPPERBOUND>
    <COST>0.0</COST>
  </ARC>
  <ARC>
    <START>event21</START>
    <END>event22</END>
    <LOWERBOUND>0.0</LOWERBOUND>
    <UPPERBOUND>+INF</UPPERBOUND>
    <COST>0.0</COST>
  </ARC>
  <ARC>
    <START>master_start</START>
    <END>noopid</END>
    <LOWERBOUND>0</LOWERBOUND>
    <UPPERBOUND>0</UPPERBOUND>
    <COST>0</COST>
  </ARC>
  <ARC>
    <START>noopid</START>
    <END>event23</END>
    <LOWERBOUND>0</LOWERBOUND>
    <UPPERBOUND>0</UPPERBOUND>
    <COST>598</COST>
  </ARC>
  <ARC>
    <START>event22</START>
    <END>noopendid</END>
    <LOWERBOUND>0</LOWERBOUND>
    <UPPERBOUND>0</UPPERBOUND>
    <COST>0</COST>
  </ARC>
  <ARC>
    <START>noopendid</START>
    <END>master_end</END>
    <LOWERBOUND>0</LOWERBOUND>
    <UPPERBOUND>+INF</UPPERBOUND>
    <COST>0</COST>
  </ARC>
  <ARC>
    <START>event21</START>
    <END>event22</END>
    <LOWERBOUND>0.040972173</LOWERBOUND>
    <UPPERBOUND>1.8027756</UPPERBOUND>
    <COST>0</COST>
    <PRIMITIVE>UAV.flyTo(&quot;92f1260c-8ce4-4f71-85c2-f71ab1cc1caa&quot;,&quot;2b990672-21df-4af3-b707-b2b247f4c593&quot;)</PRIMITIVE>
  </ARC>
</TPN>")
		 (tpn (first (tpn::parse-tpn-string tpn-xml 'tpn::get-event 'tpn::make-episode 'tpn::add-episode 'tpn::make-tpn))))
	(compute-span tpn)
	
	))