;;;; Copyright (c) 2009 Massachusetts Institute of Technology

;;;; This software may not be redistributed, and can only be retained and used
;;;; with the explicit written consent of the author, subject to the following
;;;; conditions:

;;;; The above copyright notice and this permission notice shall be included in
;;;; all copies or substantial portions of the Software.

;;;; This software may only be used for non-commercial, non-profit, research
;;;; activities.

;;;; THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESSED
;;;; OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
;;;; FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
;;;; THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
;;;; LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
;;;; FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
;;;; DEALINGS IN THE SOFTWARE.

;;;; Authors:
;;;;   David C. Wang

(in-package #:mtk-utils-2d-geometry)

(defun test1 () 
  (let* ((seg1 (make1-2d-line-segment 0 0 16 0))
		 (seg2 (make1-2d-line-segment 6 3 6 -1)))
	(format t "LINE SEG1: ~a~%" seg1)
	(format t "LINE SEG2: ~a~%" seg2)
	(format t "GET-INTERSECT ~a ~%" (get-intersection seg1 seg2))
))

(defun test2 () 
  (let* ((seg1 (make1-2d-line-segment 0 0 16 0))
		 (seg2 (make1-2d-line-segment 2 -1 2 3)))
	(format t "LINE SEG1: ~a~%" seg1)
	(format t "LINE SEG2: ~a~%" seg2)
	(format t "GET-INTERSECT? ~a ~%" (get-intersection seg1 seg2))
))

(defun test3 () 
  (let* ((polygon1 (make1-polygon 
					(list (make-2d-point 2 3)   ;o1
						  (make-2d-point 6 3)   ;o2
						  (make-2d-point 6 -1)  ;o3
						  (make-2d-point 2 -1) ))) ;o4
		 (polygon2 (make1-polygon 
					(list (make-2d-point 10 1)   ;o5
						  (make-2d-point 14 1)   ;o6
						  (make-2d-point 14 -3)   ;o7
						  (make-2d-point 10 -3) ))) ;o8
		 (seg (make1-2d-line-segment 0 0 16 0))
		)
	(format t "LINE SEG: ~a~%" seg)
	(format t "INTERSECT POLY1 ~a ~%" (intersects? polygon1 seg))
	(format t "INTERSECT POLY2 ~a ~%" (intersects? polygon2 seg))
)
)

(defun test4 () 
  (let* ((polygon (make1-polygon 
					(list (make-2d-point -7025.353 -2785.7534)     ;o1
						  (make-2d-point 4697.4854 19833.38)       ;o2
						  (make-2d-point 18075.312 -2509.9104) ))) ;o3
		 (seg1 (make1-2d-line-segment 15832.894 3367.3796 -25638.898 -9.1423)) ; start-to-goal
		 (seg2 (make1-2d-line-segment 15832.894 3367.3796 -7025.353 -2785.7534)) ;o1
		 (seg3 (make1-2d-line-segment 15832.894 3367.3796 4697.4854 19833.38))   ;o2
		 (seg4 (make1-2d-line-segment 15832.894 3367.3796 18075.312 -2509.9104)) ;o3
		)
	(format t "POLYGON: ~a~%" polygon)
	(format t "INTERSECT POLY-SEG1 ~a ~%" (intersects? polygon seg1 :include-polygon-border nil)) ;T
	(format t "INTERSECT POLY-SEG2 ~a ~%" (intersects? polygon seg2 :include-polygon-border nil)) ;T
	(format t "INTERSECT POLY-SEG3 ~a ~%" (intersects? polygon seg3 :include-polygon-border nil)) ;NIL
	(format t "INTERSECT POLY-SEG4 ~a ~%" (intersects? polygon seg4 :include-polygon-border nil)) ;NIL
)
)