;;;; Copyright (c) 2009 Massachusetts Institute of Technology

;;;; This software may not be redistributed, and can only be retained and used
;;;; with the explicit written consent of the author, subject to the following
;;;; conditions:

;;;; The above copyright notice and this permission notice shall be included in
;;;; all copies or substantial portions of the Software.

;;;; This software may only be used for non-commercial, non-profit, research
;;;; activities.

;;;; THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESSED
;;;; OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
;;;; FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
;;;; THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
;;;; LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
;;;; FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
;;;; DEALINGS IN THE SOFTWARE.

;;;; Authors:
;;;;   David C. Wang


(asdf:defsystem #:mtk-utils-2d-geometry
  :name "mtk-utils-2d-geometry"
  :version "0.1"
  :description "MERS Toolkit: 2D Geometry Library"
  :author "David Wang"
  :maintainer "MIT MERS Group"
  :components ((:file "package")
			   (:file "geometry-basics")
               (:file "2d-point"
					  :depends-on ("package" "geometry-basics"))
			   (:file "2d-line"
					  :depends-on ("package" "2d-point" "geometry-basics"))
			   (:file "2d-line-segment"
					  :depends-on ("package" "2d-line" "geometry-basics"))
			   (:file "polygon"
					  :depends-on ("package" "2d-point" "2d-line" "2d-line-segment" "geometry-basics"))
			   (:file "mtk-utils-2d-geometry-test"
					  :depends-on ("package" "geometry-basics" "2d-point" "2d-line" "2d-line-segment" "polygon"))
			   (:file "test-2d-geometry"
					  :depends-on ("package" "geometry-basics" "2d-point" "2d-line" "2d-line-segment" "polygon"))
               )
  :depends-on ("mtk-utils-infinity"))

