;;;; Copyright (c) 2009 Massachusetts Institute of Technology

;;;; This software may not be redistributed, and can only be retained and used
;;;; with the explicit written consent of the author, subject to the following
;;;; conditions:

;;;; The above copyright notice and this permission notice shall be included in
;;;; all copies or substantial portions of the Software.

;;;; This software may only be used for non-commercial, non-profit, research
;;;; activities.

;;;; THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESSED
;;;; OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
;;;; FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
;;;; THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
;;;; LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
;;;; FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
;;;; DEALINGS IN THE SOFTWARE.

;;;; Authors:
;;;;   David C. Wang

(defpackage #:mtk-utils-2d-geometry
  (:nicknames #:mtk-2d-geometry)
  (:use #:cl #:mtk-utils-infinity)
  (:export 
   ;; geometry-basics.lisp
   "EQUAL-GEO"
   "EQUALP-GEO"

   ;; 2d-point.lisp
   "X"
   "Y"
   "MAKE-2D-POINT"
   "COPY-2D-POINT"
   "GET-DISTANCE"
   "GET-2D-POINT-MIDPOINT"
   "GET-2D-POINT-SLOPE"
   "GET-DIST-FROM-ORIGIN"
  
   ;; 2d-line.lisp
   "A"
   "B"
   "C"
   "MAKE1-2D-LINE"
   "MAKE2-2D-LINE"
   "MAKE3-2D-LINE"
   "MAKE4-2D-LINE"
   "GET-SLOPE"
   "GET-INTERSECTION"
   "PARALLEL?"
   "PERPENDICULAR?"
   "COLLINEAR?"
   "VERTICAL?"
   "HORIZONTAL?"
   "GET-X-INTERCEPT"
   "GET-Y-INTERCEPT"
   "POINT-ON-LINE?"
   "DEGENERATE?"

   ;; 2d-line-segment
   "POINT1"
   "POINT2"
   "MAKE1-2D-LINE-SEGMENT"
   "MAKE2-2D-LINE-SEGMENT"
   "GET-2D-LINE"
   "GET-INTERSECTION"
   "GET-LENGTH"
   "POINT-ON-LINE?"
   "DEGENERATE?"
      
   ;; polygon.lisp
   "POINT-LIST"
   "MAKE-POLYGON"
   "MAKE1-POLYGON"
   "ADD-POINT"
   "GET-INTERSECTION"
   "GET-SEGMENTS"
   "INTERSECTS?"
   "CONTAINS?"
   "ADJACENT-POINTS?"

   )
)