;;;; Copyright (c) 2009 Massachusetts Institute of Technology

;;;; This software may not be redistributed, and can only be retained and used
;;;; with the explicit written consent of the author, subject to the following
;;;; conditions:

;;;; The above copyright notice and this permission notice shall be included in
;;;; all copies or substantial portions of the Software.

;;;; This software may only be used for non-commercial, non-profit, research
;;;; activities.

;;;; THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESSED
;;;; OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
;;;; FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
;;;; THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
;;;; LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
;;;; FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
;;;; DEALINGS IN THE SOFTWARE.

;;;; Authors:
;;;;   David C. Wang

(in-package #:mtk-utils-2d-geometry)

(mtk-utils:deftest-suite :test-2d-geometry)

(mtk-utils:deftest (test-2d-geometry-1 :test-2d-geometry) ()
  "Several polygon-point containment tests."

  (let ((pt1 (make-2d-point  0  0))
		(pt2 (make-2d-point 10  0))
		(pt3 (make-2d-point -5 -5))
		(pt4 (make-2d-point -5  5))
		(pt5 (make-2d-point  5  5))
		(pt6 (make-2d-point  5 -5)) )
	(let* ((polygon (make1-polygon (list pt3 pt4 pt5 pt6))) )
	  ;; Tests whether pt1 is contained in the internal polygon.
	  (mtk-utils:test t
					  (contains? polygon pt1 :exterior nil)
					  :test #'equalp
					  :fail-info "")
	  ;; Tests whether pt2 is not contained in the internal polygon
	  (mtk-utils:test nil
					  (contains? polygon pt2 :exterior nil)
					  :test #'equalp
					  :fail-info "")
	  ;; Tests whether pt1 is contained in the external polygon.
	  (mtk-utils:test nil
					  (contains? polygon pt1 :exterior t)
					  :test #'equalp
					  :fail-info "")
	  ;; Tests whether pt2 is not contained in the external polygon
	  (mtk-utils:test t
					  (contains? polygon pt2 :exterior t)
					  :test #'equalp
					  :fail-info "")
	  )))