(in-package cl-user)

;;; SOME SIMPLE (INCOMPLETE) TESTS OF THE SYMBOL EQUALITY METHODS

(defpackage :sympkg1 (:use :common-lisp) (:export a b c))
(in-package sympkg1)
(defvar a 'a)
(defvar b 'b)
(defvar c 'c)

(defpackage :sympkg2 (:use :common-lisp) (:export a b c))
(in-package sympkg2)
(defvar a 'a)
(defvar b 'b)
(defvar c 'c)

(in-package mtk-utils-symbol-equality)

(defun test1 () 
  (format t "(equal ~s ~s) = ~a~%"
	  sympkg1::a sympkg2::a (symbol-equal sympkg1::a sympkg2::a)))

(defun test2 ()
  (let ((list1 '(sympkg1::a sympkg1::b sympkg1::c))
	(list2 '(sympkg2::a sympkg2::b sympkg2::c)))  
    (format t "(equal ~s ~s) = ~a~%"
	    list1 list2 (symbol-equal list1 list2))))

(defun test3 ()
  (let ((list1 '(sympkg2::a sympkg1::b sympkg2::c))
	(list2 '(sympkg2::a sympkg2::b sympkg2::c)))  
    (format t "(equal ~s ~s) = ~a~%" list1 list2 (symbol-equal list1 list2))))

(defun test4 ()
  (let ((list1 '(sympkg1::a sympkg1::b (sympkg1::a sympkg1::b) sympkg1::c))
	(list2 '(sympkg2::a sympkg2::b (sympkg2::a sympkg2::b) sympkg2::c)))  
    (format t "(equal ~s ~s) = ~a~%" list1 list2 (symbol-equal list1 list2))))

(defun test5 ()
  (let ((list1 '(sympkg1::a "cat" sympkg1::b (sympkg1::a sympkg1::b) sympkg1::c
		 "dog"))
	(list2 '(sympkg2::a "CaT" sympkg2::b (sympkg2::a sympkg2::b) sympkg2::c
		 "DOG")))  
    (format t "(not (equal ~s ~s)) = ~a~%"
	    list1 list2 (not (symbol-equal list1 list2)))))

(defun test6 ()
  (let ((list1 '(sympkg1::a "cat" sympkg1::b (sympkg1::a sympkg1::b) sympkg1::c
		 "dog"))
	(list2 '(sympkg2::a "CaT" sympkg2::b (sympkg2::a sympkg2::b) sympkg2::c
		 "DOG")))  
    (format t "(equalp ~s ~s) = ~a~%"
	    list1 list2 (symbol-equalp list1 list2))))

(defun testall ()
  (test1)
  (test2)
  (test3)
  (test4)
  (test5)
  (test6))