;;; -*- Mode:Common-Lisp; Package:COMMON-LISP-USER; Base:10 -*-

;;; Copyright (c) 1999 - 2009 Brian C. Williams, MIT.

;;; This software may not be redistributed, and can only be retained
;;; and used with the explicit written consent of the author,
;;; Brian C. Williams.

;;; This software is made available as is; no guarantee is provided
;;; with respect to performance or correct behavior.

;;; This software may only be used for non-commercial, non-profit,
;;; research activities.

;;; To Do:

;;; o Put the biological pathways code into a separate system
;;;   and confirm its correct operation.

;;; o Debug the constraint-based trellis code.
;;;   Possibly place in a different system.

(in-package :cl-user)

(asdf:defsystem #:opsat
  :name "OPSAT"
  :version "0.1"
  :description "MERS Toolkit: Optimal Constraint Satisfaction"
  :author "MERS Group"
  :maintainer "MIT MERS Group"
  :serial t
  :components (
               (:file "package")
			   (:file "opsat-defs")
			   (:file "opsat-mpl-model-reader")
			   (:file "opsat-mpl-model-problem")
			   (:file "opsat-constraints-interface")
			   (:file "opsat-tracing")
			   (:file "opsat-current-state")
			   (:file "make-opsat-problem-description-elements")
			   (:file "opsat-problem") ; Note: Doesn't depend on file opsat-current-state.
			   (:file "opsat-search")
			   (:file "opsat-multi-objective")
			   (:file "test-start")
			   (:file "test-opsat-isat")
			   (:file "test-opsat-itc")
			   (:file "opsat-trellis-problem")
			   (:file "test-opsat-nqueens")
			   
)
  
  :depends-on (#:mtk-utils
			   #:bfig #:constraint-system
			   #:isat #:itc
			   #:lp-model #:lp-solver)
)

  
#+:mtk-documentation
(eval-when (:compile-toplevel :load-toplevel :execute)
   (mtk-doc:register-doc-generator (:opsat :opsat)
   	;;(:mdf "README.md")
   	(:apiref :opsat)))
