;;; Copyright (c) 1999 - 2010 Brian C. Williams, MIT.

;;; This software may not be redistributed, and can only be retained
;;; and used with the explicit written consent of the author,
;;; Brian C. Williams.

;;; This software is made available as is; no guarantee is provided
;;; with respect to performance or correct behavior.

;;; This software may only be used for non-commercial, non-profit,
;;; research activities.

(in-package :cl-user)

(defpackage :OPSAT (:use 
					"BFIG"
;;;					:ISAT ; Dependence established through CS
;;;					:ITC ; Dependence established through CS
					"CS"
					"MTK-UTILS" 
;;;					"CLOS"
					"COMMON-LISP"
					"LP-MODEL"
					"LP-SOLVER"
					)
			(:shadow model)
			(:export
			 
			 ;; From mtk-utils
			 ;; Truth values
			 "*TRUE*" "TRUE"
			 "*FALSE*" "FALSE"
			 "*NONE*" "NONE"
			 
			 "*ALWAYS-ACTIVE*"

			 ;; From ITC (can't export from ITC, would need to put in 
			 ;; MTK-utils or need opsat to use :itc).
			 ;; Bounded arithmetic
;;;			 *INFINITY* INFINITY
;;;			 *-INFINITY* -INFINITY
			 
			 ;; From CONSTRAINT-SYSTEM
			 ;; Can be used to externalize a constraint
			 ;;; system assignment, returned in an OPSAT solution.
			 "CONSTRAINT-SYSTEM-ASSIGNMENT-DESCRIPTION"

			 ;; From opsat-defs.lisp
			 "OPSAT-PROBLEM"
			 "OPSAT-PROBLEM-CONSTRAINT-SYSTEM"
			 "*NO-SUPERSET-SOLUTIONS?*"
			 "METRIC-NAME"
			 
			 "MAKE-DECISION-VARIABLE-DOMAIN-DESCRIPTION"
			 "MAKE-DECISION-VARIABLE-DOMAIN-ELEMENT-DESCRIPTION"
			 
			 "INDEXED-VARIABLE-<"
			 "ADD-INDEX-TO-ASSIGNMENT"
			 
			 "CONFLICT-DIRECTED-OPSAT-PROBLEM"
			 "OPSAT-SOLUTION"
			 "OPSAT-SOLUTION-DECISION-ASSIGNMENTS"
			 "OPSAT-SOLUTION-OBJECTIVE-FNS-COSTS-HT"
			 "OPSAT-PROBLEM-CONSTRAINT-SYSTEM"
			 
			 ;; From make-opsat-problem-description-elements.lisp
			 "MAKE-OPSAT-CLAUSE-DESCRIPTION"
			 "MAKE-OPSAT-STATE-VARIABLE-DESCRIPTION"
			 "MAKE-OPSAT-DECISION-VARIABLE-DESCRIPTION"
			 "MAKE-OPSAT-VALUED-DOMAIN-ELEMENT"
			 
			 ;; From opsat-problem.lisp
			 "NEW-OPSAT-PROBLEM"
			 "NEW-VCSP-PROBLEM" 
			 "ADD-CONSTRAINT-SYSTEM!"

			 "START-SAT-CONSTRAINTS-SET"
			 "PUSH-SAT-CONSTRAINTS"
			 "ADD-SAT-CONSTRAINTS-TO-TOP"
			 "POP-SAT-CONSTRAINTS-FROM-TOP"
			 "CLEAR-SAT-CONSTRAINTS"
			
			 "START-UNSAT-CONSTRAINTS-SET"
			 "PUSH-UNSAT-CONSTRAINTS"
			 "ADD-UNSAT-CONSTRAINTS-TO-TOP"
			 "POP-UNSAT-CONSTRAINTS-FROM-TOP"
			 "CLEAR-UNSAT-CONSTRAINTS"
			
			 ;; From opsat-constraints-interface.lisp
			 "GET-CONSTRAINT-ASSIGNMENT-OF-SEARCH-PROBLEM" 
			 "INSERT-ASSIGNMENT-INTO-CONSTRAINT-SYSTEM"
			 "REMOVE-ASSIGNMENT-FROM-CONSTRAINT-SYSTEM"
			 
			 ;; From opsat-search.lisp
			 "INITIALIZE-SEARCH-PROBLEM"
			 "FIND-SOLUTIONS"
			 "FIND-SOLUTION-OBJECTS"
			 "FIND-NEXT-SOLUTIONS"
			 
			 "FIND-MINIMAL-RELAXATIONS"

			 ;; From opsat-tracing.lisp
			 "*DEFAULT-STATE-TRACE*"
			 "STATE-TRACE"
;;;			new-state-trace
			 "INITIALIZE-STATE-TRACE!"
			 "TRACE-SEARCH-STATE"
			 "PRINT-CHECKED-SEARCH-STATES"

			 ;; From mllp-defs.lisp
			 "MLLP-THEORY"
			 "MLLP-PROBLEM"
			 "MLLP-CONSTRAINT"
			 "MLLP-SOLUTION-COLUMN-SOLUTION"
			 )
			

			(:import-from "ISAT" "THEORY"  "CLAUSE" "INSERT-CLAUSE" "GET-PROPOSITION" "FIND-PROPOSITION" "PROPOSITION-TRUTH-VALUE")
			(:import-from "ITC" 
						  "STN"			; SIMPLE-TEMPORAL NETWORK CLASS
						  "ITC-STN"
						  "START"		; Default name of start event.
						  )

			;;  (:import-from "MLLP" "NEXT-SOLUTION")
			)