(in-package :pddl)

(defun test-types-1 ()
  "Tests the add-type method by creating a simple graph."
  (let ((type-graph (make-pddl-type-graph)))
	(add-type 'a nil '(b c) type-graph)
	(add-type 'b 'a 'd type-graph)
	(add-type 'c nil 'd type-graph)
	(format t "~a" type-graph)
	))

(defun test-types-2 ()
  "Tests the union-type-graphs method by combining two simple type graphs."
  (let ((tg1 (make-pddl-type-graph))
		(tg2 (make-pddl-type-graph)))
	(format t "TG1==========~%")
	(add-type 'a nil '(b c) tg1)
	(add-type 'b 'a 'd tg1)
	(add-type 'c nil 'd tg1)
	(format t "~a" tg1)
	(format t "TG2==========~%")
	(add-type 'a nil '(e f) tg2)
	(add-type 'e 'a 'd tg2)
	(add-type 'f nil 'd tg2)
	(format t "~a" tg2)
	(format t "COPY UNION (UNION GRAPH)==========~%")
	(format t "~a" (union-type-graphs tg1 tg2 :copy t))
	(format t "COPY UNION (TG1)==========~%")
	(format t "~a" tg1)
	(format t "COPY UNION (TG2)==========~%")
	(format t "~a" tg2)
	(format t "TG2 to TG1==========~%")
	(format t "~a" (union-type-graphs tg1 tg2 :copy nil))
	))

(defun test-types-3 ()
  "Tests to make sure the add-type function removes duplicate inheritances.
   We expect to get dog->mammal->animal->object."
  (let ((type-graph (make-pddl-type-graph)))
	(add-type 'dog 'mammal nil type-graph)
	(add-type 'dog 'animal nil type-graph)
	(add-type 'mammal 'animal nil type-graph)
	(format t "=========~%")
	(format t "~a" type-graph)
	))