;;; -*- Mode:Common-Lisp; Package:COMMON-LISP-USER; Base:10 -*-

;;; Copyright (c) 2008-2010 Brian C. Williams, MIT.

;;; This software may not be redistributed, and can only be retained
;;; and used with the explicit written consent of the author,
;;; Brian C. Williams.

;;; This software is made available as is; no guarantee is provided
;;; with respect to performance or correct behavior.

;;; This software may only be used for non-commercial, non-profit,
;;; research activities.

(in-package :cl-user)

(pushnew :TPN *features*)

#+allegro
(eval-when (compile load eval) (require :sock))

(defpackage #:TPN
  (:use #:CL #:MTK-UTILS #:abstract-data-types
		#:mtk-utils-symbol-equality  #:mtk-utils-infinity
		#:S-XML #:OPSAT #:ITC #:CS #:parse-number
		#:metacopy #:temporal-constraints #:cl-ppcre
		;;;#:CLOS
		)
  (:export
   ;; From xml-tpn-reader.lisp
   ;; Parse TPN
   "PARSE-TPN-FILE"
   "PARSE-TPN-STRING"   
   "PARSE-TPN-STREAM"
			 
   ;; From xml-tpn-writer.lisp
   "WRITE-TPNS"		
   "WRITE-TPN"
			 
   ;; From create-tpn.lisp
   ;; Creating TPNs
   "MAKE-TPN"
   "GET-EVENT"
   "TPN-DECISION-EVENT!"
   "TPN-DECISION-EVENT?"
			
   "MAKE-EPISODE"
   "ADD-EPISODE"
   
   #:find-tp-event-regex
   #:event-successor-episodes
   #:episode-primitive
   ;; From choice-selection.lisp
   "INITIALIZE-TPN-CHOICE-SELECTION!"
   "SELECT-TPN-CHOICE!"
   "TPN-BEST-CHOICE"

   "FRAME-TPN-SELECTION-PROBLEM"   ;; Should this be exported?

   ;; From tpn2dot.lisp
   #:tpn2dot
   #:dot-print-tpn
   
   ;; Copying TPNs:
   #:copy-tpn
   
   ;; Accessors for TPN class:
   episode-temporal-duration
   episode-cost
   tpn-start
   tpn-end
   
   ;; For complicated manipulations of TPNs
   insert-macro-tpn!
   prefix-tpn-names
   postfix-tpn-names
   join-tpns-in-series!
   relax-tpn-loops!
   scale-tpn-costs!
   ;; Working with STNs
   ;; BCW - removed function before its defining function is 
   ;;       checked in.
;;;			 "EXTRACT-STN"

   ))
