;;; -*- Mode:Common-Lisp; Package:COMMON-LISP-USER; Base:10 -*-

;;; Copyright (c) 2008-10 Brian C. Williams, MIT.

;;; This software may not be redistributed, and can only be retained
;;; and used with the explicit written consent of the author,
;;; Brian C. Williams.

;;; This software is made available as is; no guarantee is provided
;;; with respect to performance or correct behavior.

;;; This software may only be used for non-commercial, non-profit,
;;; research activities.


;;; Fix:
;;; o Need to divide into a set of systems:
;;;    - TPN-Model
;;;    - Method-Selection
;;;    - Dispatcher
;;;    - Kirk
;;;;   - Chekov (w Kirk)

(in-package :cl-user)

(asdf:defsystem #:tpn
  :name "TPN"
  :version "0.1"
  :description "MERS Toolkit: Temporal Plan Network"
  :author "Brian C. Williams (ITC, conditional ITC) and David Wang"
  :maintainer "MIT MERS Group"
  :serial t
  :components ((:file "package")
			   (:file "defs")
			   (:file "create-TPN")

			   ;; The following two files
			   ;; support choice selection.
			   (:file "label-guards")
			   (:file "selection-problem-description")
			   (:file "choice-selection")
			   (:file "TPN-explanation")

			   (:file "XML-TPN-reader")
			   (:file "XML-TPN-writer")

			   (:file "tpn-copy")
			   (:file "tpn-manipulations")
			   (:file "tpn-transforms")

			   (:file "tpn2dot")
			   (:file "tpn2dot-test")
			
			   (:file "tests")

			   ;; The following are introduced by Patrick Conrad
			   ;; for his dispatcher.
			   (:file "extract-stn")
			   #+allegro (:file "usar-interface"))

   :depends-on (;"serial"
				;"socket"	;for tcp/ip sockets - a franz library
							; in support of usar-sim interface.
				#:itc
				#:opsat
				#:s-xml
				#:mtk-utils
				#:abstract-data-types
				#:mtk-utils-symbol-equality
				#:mtk-utils-infinity
				#:state-space
				#:constraint-system
				#:cl-ppcre
				#:parse-number
				#:metacopy
				#:temporal-constraints
				#:cl-ppcre)
)
