(in-package :tpn)

;;; Defines an interface to be used with the STN dispatcher in the extract-stn.lisp file. Very simple
;;; for now. There is a simple class USAR-INTERFACE which meets the necessary specifications. There 
;;; are also two test functions below. There is no test-suite because these must execute in real time.

(defun test-usar2 ()
  "Executes one of the test tpns. Note that a USAR-INTERFACE object is passed to the
dispatcher along with the SEND-USAR-COMMAND function."
  (let ((interface (make-instance 'usar-interface)))
	(dispatch-tpn-with-episodes "tpn/test-stn.tpn" #'send-usar-command interface  100)))

(defun test-usar ()
"Shows how a USAR interface is created and then the types of commands that are useful
for the default map."
  (let ((interface (make-instance 'usar-interface)))
	(send-usar-command interface "INIT {ClassName USARBot.ATRVJr} {Location 47.17,-55.7,-2.25}" 4)
	(send-usar-command interface "Drive {Right 4.0} {Left 4.0}" 1)
	(sleep 5)
	(send-usar-command interface "Drive {Right 0.0} {Left 0.0}" 3)
	(break))
)


;;; ***********************************************************************
;;;
;;;                USAR-INTERFACE Object
;;;
;;; ***********************************************************************

(defclass usar-interface ()
((socket
  :initform nil
  :accessor usar-socket))

(:documentation "An interface class for use with DISPATCH-TPN-WITH-EPISODES. It holds the 
socket to communicate with USARSim."))

(defmethod initialize-instance :after
	((usar-interface usar-interface) &key &allow-other-keys)
  "Prepare the object by opening a socket to USARSim."

  (setf (usar-socket usar-interface) (socket:make-socket :remote-host "127.0.0.1"
														 :remote-port 3000)))

(defmethod send-usar-command ((usar-interface usar-interface) cmd time-cmd)
  "A method for the USAR-INTERFACE which the dispatcher will use. Follows the necessary input
format (OBJECT CMD TIME-CMD). Still very elementary. Should be improved to handle more 
difficult/interesting primitives."

  (format t "Cmd issued to take: ~a ~%" time-cmd)
  (with-slots (socket) usar-interface
	(format socket "~a ~a~a" cmd #\return #\newline)
	(force-output socket)))

