;;; -*- Mode:Common-Lisp; Package:COMMON-LISP-USER; Base:10 -*-

;;; Copyright (c) 1999 - 2010 Brian C. Williams, MIT.

;;; This software may not be redistributed, and can only be retained
;;; and used with the explicit written consent of the author,
;;; Brian C. Williams.

;;; This software is made available as is; no guarantee is provided
;;; with respect to performance or correct behavior.

;;; This software may only be used for non-commercial, non-profit,
;;; research activities.


(in-package :COMMON-LISP-USER)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;
;;;           			Constraint System
;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;
;;; The essential Constraint System interface.

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(pushnew :CS *features*)

(defpackage #:CS 
  (:use #:mtk-utils #:cl)
  (:export

			 ;; Variable Descriptions
			 "MAKE-STATE-VARIABLE-DOMAIN-DESCRIPTION"

			 ;; Constraint Systems and Constraints
			 "ESSENTIAL-CONSTRAINT-SYSTEM"
;;;			 "CONSTRAINT-SYSTEM-NAME"
			 "CONSTRAINT-SYSTEM-CONSTRAINTS"
			 "CONSTRAINT-SYSTEM-INSERTED-CONSTRAINTS"
			 "CONSTRAINT-SYSTEM-BASE-CONSTRAINTS"
			 "CONSTRAINT-SYSTEM-RELAXABLE-CONSTRAINTS"
			 
			 "CONSTRAINT-SYSTEM-ASSIGNMENT-DESCRIPTION"
			 "CONSTRAINT-SYSTEM-ASSIGNMENT-DESCRIPTION-W-TRUTH"

			 "ESSENTIAL-CONSTRAINT"
			 "CONSTRAINT-SYSTEM"
			 "CONSTRAINT-CONSTRAINT-SYSTEM"
			 "CONSTRAINT-SOURCE"
			 "CONSTRAINT-REMOVED?"

			 "DEFINE-STATE-VARIABLE"

			 "NEW-CONSTRAINT"  ;; exporting causes conflicts with ITC:NEW-CONSTRAINT
			 "INSERT-CONSTRAINT"
			 "REMOVE-CONSTRAINT" ;; exporting causes conflicts with ITC:NEW-CONSTRAINT

			 "ESTABLISH-CONSTRAINTS!"

			 "GET-ASSIGNMENT"
			 "ASSIGN!"
			 "UNASSIGN!"

			 "ASSERT!"
			 "UNASSERT!"

			 "CONSISTENT?" ;; exporting causes conflicts with ITC:CONSISTENT? and ISAT:CONSISTENT?
			 "EXTERNALIZE-CONFLICT"

			 "CONSISTENT-CONSTRAINTS?"
			 "CONSISTENT-CONSTRAINTS-WITHOUT?"
			 
			 "CONSISTENT-WITH?"
			 "INCONSISTENT-WITH?"
			 "INSERT-CONSTRAINTS-AND-FIND-ALL-MODELS-IF-ANY"
			 
			 ;; Constraint System Explanation
			 "ESSENTIAL-CONSTRAINT-SYSTEM-WITH-EXPLANATION"
			 "CONFLICT-OF-CONSTRAINTS"
			 "PREFERRED-CONFLICT-OF-CONSTRAINTS"
			 "PREFERRED-RELAXATION-OF-CONSTRAINTS"
			 "ALL-CONFLICTS-OF-CONSTRAINTS"
			 "REPRESENTATIVE-EXPLANATIONS-OF-CONSTRAINTS"
			 "PREFERRED-CONFLICTS-OF-EXPLANATION"
			 "CONFLICTS-OF-REPRESENTATIVE-EXPLANATIONS"
			 "REPRESENTATIVE-EXPLANATIONS-WITH-EXPLAINED-EXCLUSIONS"
			 ))
