(in-package #:ros-interface)

(defun send-socket-message (message address port)

  ;; create a socket connection and send the message to the address and port specified
  ;; then close the socket

  ;; First create a socket

  (let ((socketConn (ignore-errors (socket:make-socket :remote-host address :remote-port port))))

	;; Next write the message to the port, given that the connection has been set up successfully

	(if socketConn

		(progn

		  (format socketConn "~A~%" message)
		  (force-output socketConn)
		  ;; close the connection
		  (close socketConn)
		  (values T))

		(progn

		  ;; Cannot send the message due to inactive socket, return nil

		  (values NIL))))

  )