;;;; Copyright (c) 2009 Massachusetts Institute of Technology

;;;; This software may not be redistributed, and can only be retained and used
;;;; with the explicit written consent of the author, subject to the following
;;;; conditions:

;;;; The above copyright notice and this permission notice shall be included in
;;;; all copies or substantial portions of the Software.

;;;; This software may only be used for non-commercial, non-profit, research
;;;; activities.

;;;; THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESSED
;;;; OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
;;;; FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
;;;; THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
;;;; LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
;;;; FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
;;;; DEALINGS IN THE SOFTWARE.

;;;; Authors:
;;;;   Patrick R. Conrad


(defpackage #:state-space
  (:nicknames "state-space")
  (:nicknames "state-space")
  (:use #:org.tfeb.hax.memoize #:mtk-utils #:cl)
  (:export
  
   ;;state-space
   state-space
   add-variables-from-descriptions!
   add-variable!

   ;;clauses
   state-clause
   get-universal-clause
   get-clause-from-descriptions
   get-clause-from-assignments
   clause-valid? ;function, will allow a nil
   state-clause-valid? ;method, won't take a nil
   state-clause-length

   clause-subsumed?
   clauses-contradictory?
   clause-intersection
   clause-list-of-assignments
   get-clause-assignment-to-var

   get-clause-assigned-vars

   remove-subsumed-clauses
   make-list-non-subsuming

   ;;conflicts
   state-space-w-conflicts
   add-conflict!
   state-clause-w-conflicts
   would-conflicts-remove-all-kernels?
   state-space-kernels
   get-valid-full-assignment
   get-all-consistent-clauses
   conflicts-to-commit-to-clause
   clause-universal?
   state-space-invalid?
   kernels-of-conflict

   split-clause-around-clauses
   commit-to-clause-allowed?
   commit-to-clause!

   ))

(mtk-utils::declare-debug-print-system! :state-space)

(mtk-utils::deftest-suite :state-space)