;;; -*- Mode:Common-Lisp; Package:COMMON-LISP-USER; Base:10 -*-

;;; Copyright (c) 2012 Eric M. Timmons, MIT.

;;; This software may not be redistributed, and can only be retained
;;; and used with the explicit written consent of the author,
;;; Eric M. Timmons.

;;; This software is made available as is; no guarantee is provided
;;; with respect to performance or correct behavior.

;;; This software may only be used for non-commercial, non-profit,
;;; research activities.

;;; Stochastics

;;; This package contains routines for Bayesian Filtering and Bayesian Learning.
;;; This includes routines for HMM estimation and Learning (Baum Welch),
;;; and estimation and learning based on single and Mixture of Gaussian Models.

(in-package #:cl-user)

(defpackage #:stochastic
  (:nicknames #:stochastic)
  (:use #:cl
        #:mtk-utils
        #+:matlisp-binary #:matlisp)
  #+:matlisp-binary
  (:shadowing-import-from "MATLISP" "REAL")
  (:export #:nondeterministic-variable
           #:random-variable

           #:sample
           
		   ;; From combinatorics.lisp
		   "RANGE"
		   "CART-PROD"
		   "PERMUTATIONS"
		   "N-PERM-K"
		   "N-CHOOSE-K"

		   ;; From discrete-probability-functions.lisp
		   "PROB-UNION"
		   "PROB-UNION-LB"
		   "PROB-UNION-UB"
		   "PROB-UNION-BOOLE"
		   "PROB-UNION-THRESHOLD"
		   "PROB-UNION-TRUNCATED"

           ;; From variable.lisp
		   "MAKE-DISCRETE-RV"
           "MAKE-ASSIGNMENT-RV"
           
		   ;; From probability-model.lisp
		   "MAKE-COND-PROB"
		   "MAKE-PROB-MODEL"		   
		   "ADD-TO-PROB-MODEL"
		   "GET-PROB-VALUE-FROM-MODEL"
		   "CHECK-SANITY-PROB-MODEL"

		   ;; From inference.lisp
		   "COMPUTE-JOINT-PROBABILITY"		   
		   "COMPUTE-JOINT-PROBABILITY-ALL-CONDITIONALLY-INDEPENDENT"		   
		   ))
