;;; -*- Mode:Common-Lisp; Package:COMMON-LISP-USER; Base:10 -*-

;;; Copyright (c) 2012 Eric M. Timmons, MIT.

;;; This software may not be redistributed, and can only be retained
;;; and used with the explicit written consent of the author,
;;; Eric M. Timmons.

;;; This software is made available as is; no guarantee is provided
;;; with respect to performance or correct behavior.

;;; This software may only be used for non-commercial, non-profit,
;;; research activities.

(asdf:defsystem #:stochastic
  :name "Stochastic Toolkit" 
  :version "0.1"
  :description "MERS Toolkit: Stochastic Toolkit"
  :author "MERS Group"
  :maintainer "MIT MERS Group"
  :serial t
  :components((:file "package")
			  (:file "convert")
			  (:file "conditions")
			  (:module "domains"
					   :pathname "domains/"
					   :components ((:file "domain")
									(:file "discrete-domains")
									(:file "continuous-domains")))
			  (:module "distributions"
					   :pathname "distributions/"
					   :depends-on ("domains")
					   :components ((:file "distribution")
									(:file "distribution-utilities")
									(:file "uniform/uniform-distribution")
									(:file "gaussians/gaussians")
									(:file "gaussians/univariate-gaussians")
									#+:matlisp-binary
									(:file "gaussians/multivariate-gaussians")
									(:file "gaussians/scalar-normal-distribution")
									#+:matlisp-binary
									(:file "gaussians/matlisp-normal-distribution")
									#+:matlisp-binary
									(:file "mixture-of-gaussians/gmm")))
			  
			  (:file "combinatorics")
			  (:file "discrete-probability-functions")
			  (:file "probability-model")
			  (:file "inference")

			  (:file "tests/tests")
			  (:file "tests/tests-discrete")
			  
			  (:file "variable")
)
  :depends-on (#:mtk-utils 
			   #+:matlisp-binary #:matlisp))
