;;;; Copyright (c) 2012 Massachusetts Institute of Technology

;;;; This software may not be redistributed, and can only be retained and used
;;;; with the explicit written consent of the author, subject to the following
;;;; conditions:

;;;; The above copyright notice and this permission notice shall be included in
;;;; all copies or substantial portions of the Software.

;;;; This software may only be used for non-commercial, non-profit, research
;;;; activities.

;;;; THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESSED
;;;; OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
;;;; FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
;;;; THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
;;;; LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
;;;; FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
;;;; DEALINGS IN THE SOFTWARE.

;;;; Authors:
;;;;   Seung H. Chung, David C. Wang

(asdf:defsystem #:tburton
  :name "MERS Toolkit: Constraint and Causal Order Decomposition Planner"
  :version "0.1"
  :description ""
  :author "David Wang"
  :maintainer "MIT MERS Group"
  :serial t
  :components ((:file "package")
			   (:file "domains" :depends-on ("package"))
			   (:file "logic" :depends-on ("domains"))
			   (:file "gp" :depends-on ("logic"))
			   
			   (:file "pddl-to-snark"
					  :depends-on ("package"))
			   (:file "test-pddl-to-snark"
					  :depends-on ("package" "pddl-to-snark"))
			   (:file "invariant-synthesis"
					  :depends-on ("package"))
			   (:file "test-invariant-synthesis"
					  :depends-on ("package" "invariant-synthesis"))
               (:file "planner" :depends-on ("package" "gp"))
			   (:file "planner-test" :depends-on ("package" "planner"))
			   (:file "tburton" :depends-on ("package" "planner"))
			   (:file "tburton-socket-interface" :depends-on ("tburton"))
			   (:file "test-tburton" :depends-on ("package" "tburton"))
			   (:file "stn" :depends-on ("package"))
			   (:file "test-stn" :depends-on ("package" "stn"))
			   (:file "tburton-executable" :depends-on ("package" "tburton"))
			   (:file "schedule-offline" :depends-on ("package"))
			   (:file "test-schedule-offline" :depends-on ("package" "schedule-offline"))
	       )
  :depends-on (#:mtk-qsp #:mtk-graph #:kirk #:itc #:tpn
						 #:mtk-utils-infinity
						 ;; required for file tburton-socket-interface
						 #:ros-interface
						 ;; required for simple implementation of temporal consistency
						 ;; required for computing standard IPC plan, with no flexible time.
						 #:simplex
						 #:abstract-data-types
						 #:pddl
						 #:mtk-graph
						 #:mtk-graph-algorithms))
