;;;; Copyright (c) 2013 Massachusetts Institute of Technology

;;;; This software may not be redistributed, and can only be retained and used
;;;; with the explicit written consent of the author, subject to the following
;;;; conditions:

;;;; The above copyright notice and this permission notice shall be included in
;;;; all copies or substantial portions of the Software.

;;;; This software may only be used for non-commercial, non-profit, research
;;;; activities.

;;;; THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESSED
;;;; OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
;;;; FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
;;;; THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
;;;; LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
;;;; FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
;;;; DEALINGS IN THE SOFTWARE.

(defpackage #:temporal-constraints
  (:use #:cl
		#:metacopy)
  (:export
   ;; Classes for working with Durations and costs:
   temporal-duration
   bounded-temporal-duration
   looping-temporal-duration
   
   episode-cost
   constant-episode-cost
   looping-episode-cost
   linear-looping-episode-cost
   calculate-looping-cost
   
   looping-cost-per-loop
   looping-setup-cost
   ltd-per-loop-duration
   ltd-n-lower-bound
   ltd-n-upper-bound
   btd-upper-bound
   btd-lower-bound
   constant-episode-cost-cost
)
  )

