;;; -*- Mode:Common-Lisp; Package:TPN; Base:10 -*-

;;; Copyright (c) 2013


(in-package :temporal-constraints)

(defclass episode-cost (copyable-mixin)
  ()
  (:documentation "Base class for the cost of an episode."))

(defclass constant-episode-cost (episode-cost)
  ((cost :initarg :cost
		 :accessor constant-episode-cost-cost
		 :initform 0
		 :documentation "Cost of executing episode.")))

(defclass looping-episode-cost (episode-cost)
  ())

(defclass linear-looping-episode-cost (looping-episode-cost)
  ((cost-per-loop :initarg :cost-per-loop
				  :accessor looping-cost-per-loop
				  :initform 0
				  :documentation "The constant cost per loop.")
   (setup-cost :initarg :setup-cost
			   :accessor looping-setup-cost
			   :initform 0
			   :documentation "The setup cost, independent of number of loops.")))

(defgeneric calculate-looping-cost (looping-cost-object number-of-loops))

(defmethod calculate-looping-cost ((looping-cost-object linear-looping-episode-cost) number-of-loops)
  (with-slots (setup-cost cost-per-loop) looping-cost-object
	(+ setup-cost (* cost-per-loop number-of-loops))))
