;;;; Copyright (c) 2009 Massachusetts Institute of Technology

;;;; This software may not be redistributed, and can only be retained and used
;;;; with the explicit written consent of the author, subject to the following
;;;; conditions:

;;;; The above copyright notice and this permission notice shall be included in
;;;; all copies or substantial portions of the Software.

;;;; This software may only be used for non-commercial, non-profit, research
;;;; activities.

;;;; THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESSED
;;;; OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
;;;; FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
;;;; THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
;;;; LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
;;;; FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
;;;; DEALINGS IN THE SOFTWARE.

;;;; Authors:
;;;;   David C. Wang
;;;;   Alborz Geramifard

(in-package #:cl-user)

(defpackage #:visibility-graph
  (:use #:cl #:cl-user #:asdf #:mtk-utils-2d-geometry #:mtk-utils-infinity #:abstract-data-types #:s-xml #:parse-number #:mtk-graph #:mtk-graph-algorithms #:tpn)
  (:export 
   ;; from floyd-warshall.lisp 
   #:apsp-full-num-nodes
   #:apsp-full-cost-matrix
   #:apsp-full-shortcut-matrix
   #:make-apsp-full
   #:set-cost
   #:get-cost
   #:get-cost-from-path
   #:get-path
   #:floyd-warshall
   #:make-apsp-symm
   #:make-apsp  

   ;; from visibility-graph.lisp
   #:vg-vertex-ht
   #:vg-vertex-array
   #:vg-apsp
   #:make-visibility-graph
   #:intersects-obstacle?
   #:vg-get-index?
   #:get-cost
   #:get-cost-from-path
   #:get-path

   )
)

